MODEL=ALLNET
SOURCE_DIR=../user
RAMDISK=root_12M.gz 
LOGIN_NAME=hearn
all: 
	make -C $(SOURCE_DIR)/busybox all; 
	make -C $(SOURCE_DIR)/httpd all; 
	make -C $(SOURCE_DIR)/thttpd all; 
	make -C $(SOURCE_DIR)/checksmb all; 
	make -C $(SOURCE_DIR)/real all; 
	make -C $(SOURCE_DIR)/sp all; 
	make -C $(SOURCE_DIR)/wget-1.9.1 all; 
	make -C $(SOURCE_DIR)/inetd all; 
	make -C $(SOURCE_DIR)/libns all; 
	make -C $(SOURCE_DIR)/ifattach all; 
clean: 
	make -C $(SOURCE_DIR)/busybox clean; 
	make -C $(SOURCE_DIR)/httpd clean; 
	make -C $(SOURCE_DIR)/thttpd clean; 
	make -C $(SOURCE_DIR)/checksmb clean; 
	make -C $(SOURCE_DIR)/real clean; 
	make -C $(SOURCE_DIR)/sp clean; 
	make -C $(SOURCE_DIR)/wget-1.9.1 clean; 
	make -C $(SOURCE_DIR)/inetd clean; 
	make -C $(SOURCE_DIR)/libns clean; 
	make -C $(SOURCE_DIR)/ifattach clean; 
install: prepare 
	sudo rm -rf root/*; 
	sudo rm -rf aptools/*; 
	make -C $(SOURCE_DIR)/busybox install; 
	make -C $(SOURCE_DIR)/httpd install; 
	make -C $(SOURCE_DIR)/thttpd install; 
	make -C $(SOURCE_DIR)/checksmb install; 
	make -C $(SOURCE_DIR)/real install; 
	make -C $(SOURCE_DIR)/sp install; 
	make -C $(SOURCE_DIR)/wget-1.9.1 install; 
	make -C $(SOURCE_DIR)/inetd install; 
	make -C $(SOURCE_DIR)/libns install; 
	make -C $(SOURCE_DIR)/ifattach install; 
clean_all_user: 
	make -C $(SOURCE_DIR)/busybox clean; 
	make -C $(SOURCE_DIR)/httpd clean; 
	make -C $(SOURCE_DIR)/e2fsprogs clean; 
	make -C $(SOURCE_DIR)/ftp clean; 
	make -C $(SOURCE_DIR)/checksmb clean; 
	make -C $(SOURCE_DIR)/power_down clean; 
	make -C $(SOURCE_DIR)/route clean; 
	make -C $(SOURCE_DIR)/sp clean; 
	make -C $(SOURCE_DIR)/inetd clean; 
	make -C $(SOURCE_DIR)/real clean; 
	make -C $(SOURCE_DIR)/wget-1.9.1 clean; 
	make -C $(SOURCE_DIR)/gnuftpd clean; 
	make -C $(SOURCE_DIR)/sysutils clean; 
	make -C $(SOURCE_DIR)/iconv_ftpd clean; 
	make -C $(SOURCE_DIR)/tftpd clean; 
	make -C $(SOURCE_DIR)/thttpd clean; 
	make -C $(SOURCE_DIR)/ifattach clean; 
	make -C $(SOURCE_DIR)/libns clean; 
	make -C $(SOURCE_DIR)/gnuftpd_nh220 clean; 
	make -C $(SOURCE_DIR)/httpd_09112006 clean; 
	make -C $(SOURCE_DIR)/p2p clean; 
	make -C $(SOURCE_DIR)/httpd_no_big5 clean; 
	make -C $(SOURCE_DIR)/httpd_unicode clean; 
