#!/bin/sh
DEV_FILE="/proc/bus/usb/devices"

NUM_PRINTER=`grep -c usblp $DEV_FILE`

if grep UHCI /proc/bus/usb/devices ; then
	USB11=UHCI
else
	USB11=OHCI
fi

if [ "$NUM_PRINTER" -eq "0" ] ; then
		rm /etc/printcap >/dev/null 2>&1
		sed '/PRINTER_ENABLE/s/[0-1]/0/' /etc/config > /tmp/config2
		mv /tmp/config2 /etc/config
		kill -s SIGHUP `pidof httpd`
else
	mkdir -p /mnt/spool/samba
	[ "$NUM_PRINTER" -ge "1" ] && {
	
		if [ "$USB11" = "UHCI" ] ; then
			# this is genesis chip
			PROS=`grep -v "UHCI Root Hub" $DEV_FILE | grep -v "PCI device" | grep -c Product`		
			PRNT_LINE=`grep -n usblp $DEV_FILE | cut -d: -f1 | head -n 1`
			
			[ "$PROS" -eq "1" ] && {
				PRINTER_NAME=`grep -v "UHCI Root Hub" $DEV_FILE | grep -v "PCI device" | grep Product | cut -d= -f2`			
			} || {
				PRO_LINE1=`grep -nv "UHCI Root Hub" $DEV_FILE | grep -v "PCI device" | grep Product | cut -d: -f1 | head -n 1`
				PRO_LINE2=`grep -nv "UHCI Root Hub" $DEV_FILE | grep -v "PCI device" | grep Product | cut -d: -f1 | tail -n 1`
				
				[ "$PRO_LINE2" -gt "$PRNT_LINE" ] \
				 && PRINTER_NAME=`grep -n : $DEV_FILE | grep $PRO_LINE1: | cut -d= -f2` \
				 || PRINTER_NAME=`grep -n : $DEV_FILE | grep $PRO_LINE2: | cut -d= -f2`
	
			}
				
		else
			# this is nec chip
			PROS=`grep -v "NEC Corporation\|USB OHCI Root Hub" $DEV_FILE | grep -c Product`		
			PRNT_LINE=`grep -n usblp $DEV_FILE | cut -d: -f1 | head -n 1`
			
			[ "$PROS" -eq "1" ] && {
				PRINTER_NAME=`grep -v "NEC Corporation\|USB OHCI Root Hub" $DEV_FILE | grep Product | cut -d= -f2`			
			} || {
				PRO_LINE1=`grep -nv "NEC Corporation\|USB OHCI Root Hub" $DEV_FILE | grep Product | cut -d: -f1 | head -n 1`
				PRO_LINE2=`grep -nv "NEC Corporation\|USB OHCI Root Hub" $DEV_FILE | grep Product | cut -d: -f1 | tail -n 1`
				
				[ "$PRO_LINE2" -gt "$PRNT_LINE" ] \
				 && PRINTER_NAME=`grep -n : $DEV_FILE | grep $PRO_LINE1: | cut -d= -f2` \
				 || PRINTER_NAME=`grep -n : $DEV_FILE | grep $PRO_LINE2: | cut -d= -f2`
	
			}		
				
		fi
		
		
		mkdir -p /mnt/spool/lp0;chmod 700 /mnt/spool/lp0
		cp /etc/printcap1 /etc/printcap
		
	
	    if [ -n "$PRINTER_NAME" ] ; then
			sed "1c \lp0|$PRINTER_NAME:" /etc/printcap > /tmp/printcap
			sed '/lp0|/s/:/:\\/' /tmp/printcap > /etc/printcap
	    else
			rm /etc/printcap >/dev/null 2>&1
			sed '/PRINTER_ENABLE/s/[0-1]/0/' /etc/config > /tmp/config2
			mv /tmp/config2 /etc/config
			kill -s SIGHUP `pidof httpd`
	    fi				
	} || {
	
		if [ "$USB11" = "UHCI" ] ; then
			PRINTER_NAME=`grep -nv "UHCI Root Hub" $DEV_FILE | grep -v "PCI device" | grep Product | cut -d= -f2 | head -n 1`
		else
			PRINTER_NAME=`grep -nv "NEC Corporation\|USB OHCI Root Hub" $DEV_FILE | grep Product | cut -d= -f2 | head -n 1`
		fi
		
		mkdir -p /mnt/spool/lp0;chmod 700 /mnt/spool/lp0
		cp /etc/printcap1 /etc/printcap
			
	    if [ -n "$PRINTER_NAME" ] ; then
			sed "1c \lp0|$PRINTER_NAME:" /etc/printcap > /tmp/printcap
			sed '/lp0|/s/:/:\\/' /tmp/printcap > /etc/printcap
	    else
			rm /etc/printcap >/dev/null 2>&1
			sed '/PRINTER_ENABLE/s/[0-1]/0/' /etc/config > /tmp/config2
			mv /tmp/config2 /etc/config
			kill -s SIGHUP `pidof httpd`
	    fi		
	}

	if ! pidof lpd ; then
		/mnt/lpd
	fi	
	kill -s SIGHUP `pidof smbd`
fi

