#!/bin/sh
for i in /dev/sda /dev/sdb /dev/sdc /dev/sdd
do	
	TEST=`fdisk -l $i | grep Disk | cut -b1-4`
	#fdisk -l $i >/dev/null 2>&1
    [ -n "${TEST}" ] && 
 	{       
       capacity=`fdisk -l $i | head -n 2 | tail -n 1 | cut -d: -f2 \
                     | cut -d, -f1 | cut -d' ' -f2`
            
       capacity_unit=`fdisk -l $i | head -n 2 | tail -n 1 | cut -d: -f2 \
                     | cut -d, -f1 | cut -d' ' -f3`
                                          
       PARTS_NUM=`fdisk -l $i | grep -c $i`
       PARTS_NUM=$(($PARTS_NUM-1))
       echo "$i:partitions=${PARTS_NUM}:total=${capacity}${capacity_unit}"
       
          x=1
	      while [ "$x" -le "$PARTS_NUM" ]
		  do
		  	DEV_PART=`fdisk -l $i | grep $i | head -n $(($x+1)) | tail -n 1 | cut -b1-9`
		  	{
			  GUESS_FS=`fdisk -l $i | grep $i | head -n $(($x+1)) | tail -n 1 | cut -b54`
			  case "$GUESS_FS" in
			  f) x=$(($x+1))
			     continue ;;
			  b|c) DEV_FS="FAT32" ;;
			  e|4|6) DEV_FS="FAT16" ;;
			  *)				 			  
			     DEV_FS=`fdisk -l $i | grep $i | head -n $(($x+1)) | tail -n 1 | tr ' ' '\n' | tail -n 1`
			     ;;
			  esac			
			}
			BOOT_MARK=`fdisk -l $i | grep $i | head -n $(($x+1)) | tail -n 1 | grep \* | cut -d' ' -f1` 
			[ -n "$BOOT_MARK" ] && BOOTABLE="1" || BOOTABLE="0"
			
			[ "$BOOTABLE" -eq 0 ] && \
			DEV_BLOCK=`fdisk -l $i | grep $i | head -n $(($x+1)) | tail -n 1 | tr ' ' '\n' | grep -v ^$ | head -n 4 | tail -n 1 | cut -d+ -f1` || \
			DEV_BLOCK=`fdisk -l $i | grep $i | head -n $(($x+1)) | tail -n 1 | tr ' ' '\n' | grep -v ^$ | head -n 5 | tail -n 1 | cut -d+ -f1`
			
			
			
			DEV_CAP="$(($DEV_BLOCK/1000))"
			echo "${DEV_PART}:filetype=${DEV_FS}:total=${DEV_CAP}MB"
			    
		    x=$(($x+1))
		  done
       
       

    } 
    #|| echo "$i doesn't exit!!"
done
