#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "include/httpd_sysconf.h"

#define DEBUG
#undef DEBUG
extern struct{
    char DHCP_ENABLE[2];
    char IP[20];
    char GATEWAY[20];
    char NETMASK[20];
    char HOSTNAME[17];
    char WORKGROUP[17];
    char HOSTNAME_FULL[51];
    char USERNAME[20];
    char PASSWORD[20];
    char FTP_MAX_UNIT[3];
	char FTP_PORT_NUMBER[6];
	char FTP_TIMEOUT[4];
	char FTP_ANONYMITY[2];
	char FTP_ENABLE[2];
	char LEGAL_IP[10][20];
	char IP_SECURITY_MODE[2];
	char LEGAL_MAC[10][30];
	char MAC_SECURITY_MODE[2];
	char TIME_MODE[2];
	char TIME_SERVER[40];
	char TIME_ZONE[25];
	char TIME_DIFFER[10];
	char TIME_VALUE[30];
	char DNS_SERVER[20];
	char CODE_SET[20];
	char TCONFIG_FOLDER[17];
	char TCONFIG_FILENAME[17];
	char TORRENT_USER[3];
	char TORRENT_ENABLE[2];
	char WEB_ENABLE[2];
	char WEB_PORT[6];
	char WEB_FOLDER[17];
	char CRON_ENABLE[2];
	char CRON_START_DAY[2];
	char CRON_START_HOUR[3];
	char CRON_START_MIN[3];
	char CRON_END_DAY[2];
	char CRON_END_HOUR[3];
	char CRON_END_MIN[3];
	char ADMIN_PORT[6];
	char USB_SHARE[2];
	char USB_RECYCLE[2];
//=======================allen adds to declaration USB saveconfiguration=======================
  char SERVER[2];
  //char SERVER2[2];
//=============================================================================================	
//=======================allen adds to declaration JUMBO saveconfiguration=======================
	char JUMBO[2];
//===============================================================================================
//========== allen adds to svae PORT series	===========
  char USB_PORT01[60];
  char USB_PORT02[60];
  char USB_PORT03[60];
  char USB_PORT04[60];
  char USB_PORT11[60];
  char USB_PORT12[60];
  char USB_PORT13[60];
  char USB_PORT14[60];
  char USB_PORT21[60];
  char USB_PORT22[60];
  char USB_PORT23[60];
  char USB_PORT24[60];
  char USB_PORT31[60];
  char USB_PORT32[60];
  char USB_PORT33[60];
  char USB_PORT34[60];
	char SWAP_ENABLE[5];
//===================================================================================================
//======================= allen adds to saving checksmb parameter =======================
	char INITBOOT[2];
//===============================================================================================
#if defined(PCI)	
	char INTERFACE_SET[20]; //UI Language
#endif
}CONFIG;

int ReadConfiguration(void){
    
    FILE *fip;
    char LineBuf[256], TagName[15];
    char *ptr, *end;
    int i=0;
      
    if((fip = fopen("/etc/config","r")) == NULL)  
        return 0;

    while(fgets(LineBuf,255,fip) != NULL){
        for(i=0;i<255;i++){
            if((LineBuf[i] == ' ') || (LineBuf[i] == '\n') || (LineBuf[i] == '\r')){
	            LineBuf[i] = '\0';
	            i=256;
	        }
	    }
	    if((ptr = strstr(LineBuf,"IP='")) != NULL){
	        ptr+=4;
	        end = strchr(ptr,'\'');
	        *end = '\0';
	        strcpy(CONFIG.IP,ptr);
	    }
	    if((ptr = strstr(LineBuf,"GATEWAY='")) != NULL){
	        ptr+=9;
	        end = strchr(ptr,'\'');
	        *end = '\0';
	        strcpy(CONFIG.GATEWAY, ptr);
	    }            
	    if((ptr = strstr(LineBuf,"NETMASK='")) != NULL){
	        ptr+=9;
	        end = strchr(ptr,'\'');
	        *end = '\0';
	        strcpy(CONFIG.NETMASK, ptr);
	    }
	    if((ptr = strstr(LineBuf,"HOSTNAME='")) != NULL){
	        ptr+=10;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.HOSTNAME, ptr);
	    }
	    if((ptr = strstr(LineBuf,"WORKGROUP='")) != NULL){
	        ptr+=11;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.WORKGROUP, ptr);
	    }                   
	    if((ptr = strstr(LineBuf,"HOSTNAME_FULL='")) != NULL){
	        ptr+=15;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	            strcpy(CONFIG.HOSTNAME_FULL, ptr);
	    }       
	    if((ptr = strstr(LineBuf,"USERNAME='")) != NULL){
	        ptr+=10;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USERNAME, ptr);
	    }    
	    if((ptr = strstr(LineBuf,"PASSWORD='")) != NULL){
	        ptr+=10;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.PASSWORD, ptr);
	    }
	    if((ptr = strstr(LineBuf,"FTP_MAX='")) != NULL){
	        ptr+=9;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.FTP_MAX_UNIT, ptr);
	    }
	    if((ptr = strstr(LineBuf,"FTP_PORT='")) != NULL){
	        ptr+=10;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.FTP_PORT_NUMBER, ptr);
	    }
	    if((ptr = strstr(LineBuf,"FTP_TIMEOUT='")) != NULL){
	        ptr+=13;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.FTP_TIMEOUT, ptr);
	    }
	    if((ptr = strstr(LineBuf,"FTP_ANONYMITY='")) != NULL){
	        ptr+=15;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.FTP_ANONYMITY, ptr);
	    }
	    if((ptr = strstr(LineBuf,"FTP_ENABLE='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.FTP_ENABLE, ptr);
	    }
	    if((ptr = strstr(LineBuf,"DHCP_ENABLE='")) != NULL){
	        ptr+=13;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.DHCP_ENABLE, ptr);
	    }
	    for(i=0;i<10;i++){
	    	sprintf(TagName,"LEGAL_IP%d='",i+1);
	        if((ptr = strstr(LineBuf,TagName)) != NULL){
	        	if(i<9)
	                ptr+=11;
	            else
	                ptr+=12;
	            end = strchr(ptr,'\'');
	    	    *end = '\0';
	            strcpy(CONFIG.LEGAL_IP[i], ptr);
	        }
	    }
	    if((ptr = strstr(LineBuf,"IP_SECURITY_MODE='")) != NULL){
	        ptr+=18;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.IP_SECURITY_MODE, ptr);
	    }
	    for(i=0;i<10;i++){
	    	sprintf(TagName,"LEGAL_MAC%d='",i+1);
	        if((ptr = strstr(LineBuf,TagName)) != NULL){
	        	if(i<9)
	                ptr+=12;
	            else
	                ptr+=13;
	            end = strchr(ptr,'\'');
	    	    *end = '\0';
	            strcpy(CONFIG.LEGAL_MAC[i], ptr);
	        }
	    }
	    if((ptr = strstr(LineBuf,"MAC_SECURITY_MODE='")) != NULL){
	        ptr+=19;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.MAC_SECURITY_MODE, ptr);
	    }
	    if((ptr = strstr(LineBuf,"TZ='")) != NULL){
	        ptr+=4;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.TIME_DIFFER, ptr);
	    }
	    if((ptr = strstr(LineBuf,"TIME_ZONE='")) != NULL){
	        ptr+=11;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.TIME_ZONE, ptr);
	    }
	    if((ptr = strstr(LineBuf,"TIME_MODE='")) != NULL){
	        ptr+=11;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.TIME_MODE, ptr);
	    }
	    if((ptr = strstr(LineBuf,"TIME_SERVER='")) != NULL){
	        ptr+=13;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.TIME_SERVER, ptr);
	    }
	    if((ptr = strstr(LineBuf,"DNS_SERVER='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.DNS_SERVER, ptr);
	        //printf("DNS_SERVER=%s\n",CONFIG.DNS_SERVER);
	    }
	    if((ptr = strstr(LineBuf,"CODE_SET='")) != NULL){
	        ptr+=10;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CODE_SET, ptr);
	        //printf("CONFIG.CODE_SET=%s\n",CONFIG.CODE_SET);
	    }

	    if((ptr = strstr(LineBuf,"TCONFIG_FOLDER='")) != NULL){
	        ptr+=16;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.TCONFIG_FOLDER, ptr);
	    }
	    if((ptr = strstr(LineBuf,"TCONFIG_FILENAME='")) != NULL){
	        ptr+=18;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.TCONFIG_FILENAME, ptr);
	    }
	    if((ptr = strstr(LineBuf,"TORRENT_USER='")) != NULL){
	        ptr+=14;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.TORRENT_USER, ptr);
	    }
	    if((ptr = strstr(LineBuf,"TORRENT_ENABLE='")) != NULL){
	        ptr+=16;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.TORRENT_ENABLE, ptr);
	    }
	    if((ptr = strstr(LineBuf,"WEB_ENABLE='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.WEB_ENABLE, ptr);
	    }
	    if((ptr = strstr(LineBuf,"WEB_PORT='")) != NULL){
	        ptr+=10;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.WEB_PORT, ptr);
	    }
	    if((ptr = strstr(LineBuf,"WEB_FOLDER='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.WEB_FOLDER, ptr);
	    }
	    if((ptr = strstr(LineBuf,"CRON_ENABLE='")) != NULL){
	        ptr+=13;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CRON_ENABLE, ptr);
	    }
	    if((ptr = strstr(LineBuf,"CRON_START_DAY='")) != NULL){
	        ptr+=16;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CRON_START_DAY, ptr);
	    }
	    if((ptr = strstr(LineBuf,"CRON_START_HOUR='")) != NULL){
	        ptr+=17;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CRON_START_HOUR, ptr);
	    }
	    if((ptr = strstr(LineBuf,"CRON_START_MIN='")) != NULL){
	        ptr+=16;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CRON_START_MIN, ptr);
	    }
	    if((ptr = strstr(LineBuf,"CRON_END_DAY='")) != NULL){
	        ptr+=14;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CRON_END_DAY, ptr);
	    }
	    if((ptr = strstr(LineBuf,"CRON_END_HOUR='")) != NULL){
	        ptr+=15;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CRON_END_HOUR, ptr);
	    }
	    if((ptr = strstr(LineBuf,"CRON_END_MIN='")) != NULL){
	        ptr+=14;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CRON_END_MIN, ptr);
	    }
	    if((ptr = strstr(LineBuf,"ADMIN_PORT='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.ADMIN_PORT, ptr);
	    }
	    if((ptr = strstr(LineBuf,"USB_SHARE='")) != NULL){
	        ptr+=11;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_SHARE, ptr);
	    }
	    if((ptr = strstr(LineBuf,"USB_RECYCLE='")) != NULL){
	        ptr+=13;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_RECYCLE, ptr);
	    }
//===========allen adds to save Printer Setup variable=============	    
	    if((ptr = strstr(LineBuf,"PRINTER_ENABLE='")) != NULL){
	        ptr+=16;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.SERVER, ptr);
	        //printf("readconfiguration server=%s\n",CONFIG.SERVER);
	    }
	    /*
	    if((ptr = strstr(LineBuf,"PRINTER_ENABLE2='")) != NULL){
	        ptr+=17;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.SERVER2, ptr);
	        //printf("readconfiguration server2=%s\n",CONFIG.SERVER2);
	    }
	    */
//=================================================================
//==========================Jumbo Frame============================
      if((ptr = strstr(LineBuf,"JUMBO='")) != NULL){
	        ptr+=7;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.JUMBO, ptr);
	        //printf("readconfiguration JUMBO=%s\n",CONFIG.JUMBO);
	    }
//=================================================================
	    if((ptr = strstr(LineBuf,"SWAP_ENABLE='")) != NULL){
	        ptr+=13;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.SWAP_ENABLE, ptr);
	        
	        //printf("read;CONFIG.SWAP_ENABLE=%s\n",CONFIG.SWAP_ENABLE);   	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT01='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT01, ptr);
	        //printf("CONFIG.USB_PORT01 = %s\n", CONFIG.USB_PORT01);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT02='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT02, ptr);
	        //printf("CONFIG.USB_PORT02 = %s\n", CONFIG.USB_PORT02);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT03='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT03, ptr);
	        //printf("CONFIG.USB_PORT03 = %s\n", CONFIG.USB_PORT03);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT04='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT04, ptr);
	        //printf("CONFIG.USB_PORT04 = %s\n", CONFIG.USB_PORT04);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT11='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT11, ptr);
	        //printf("CONFIG.USB_PORT11 = %s\n", CONFIG.USB_PORT11);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT12='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT12, ptr);
	        //printf("CONFIG.USB_PORT12 = %s\n", CONFIG.USB_PORT12);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT13='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT13, ptr);
	        //printf("CONFIG.USB_PORT13 = %s\n", CONFIG.USB_PORT13);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT14='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT14, ptr);
	        //printf("CONFIG.USB_PORT14 = %s\n", CONFIG.USB_PORT14);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT21='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT21, ptr);
	        //printf("CONFIG.USB_PORT21 = %s\n", CONFIG.USB_PORT21);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT22='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT22, ptr);
	        //printf("CONFIG.USB_PORT22 = %s\n", CONFIG.USB_PORT22);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT23='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT23, ptr);
	        //printf("CONFIG.USB_PORT23 = %s\n", CONFIG.USB_PORT23);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT24='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT24, ptr);
	        //printf("CONFIG.USB_PORT24 = %s\n", CONFIG.USB_PORT24);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT31='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT31, ptr);
	        //printf("CONFIG.USB_PORT31 = %s\n", CONFIG.USB_PORT31);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT32='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT32, ptr);
	        //printf("CONFIG.USB_PORT32 = %s\n", CONFIG.USB_PORT32);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT33='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT33, ptr);
	        //printf("CONFIG.USB_PORT33 = %s\n", CONFIG.USB_PORT33);
	       
	    }
	    if((ptr = strstr(LineBuf,"USB_PORT34='")) != NULL){
	        ptr+=12;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.USB_PORT34, ptr);
	        //printf("CONFIG.USB_PORT34 = %s\n", CONFIG.USB_PORT34);
	       
	    }
	    if((ptr = strstr(LineBuf,"INITBOOT='")) != NULL){
	        ptr+=10;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.INITBOOT, ptr);
	        //printf("CONFIG.USB_PORT34 = %s\n", CONFIG.USB_PORT34);
	       
	    }
#if defined(PCI)	    
	    if((ptr = strstr(LineBuf,"INTERFACE_SET='")) != NULL){
	        ptr+=15;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.INTERFACE_SET, ptr);
	        //printf("CONFIG.INTERFACE_SET=%s\n",CONFIG.INTERFACE_SET);
	    }
#endif	    
//=================================================================
//==========================CODE_PAGE============================
      /*
      if((ptr = strstr(LineBuf,"CODE_SET='")) != NULL){
	        ptr+=10;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(CONFIG.CODE_PAGE, ptr);
	        printf("save CONFIG.CODE_PAGE=%s\n",CONFIG.CODE_PAGE);
	    }
	    */
//=================================================================  
	}
	fclose(fip);
    return 1;
}

int SaveConfiguration(void){
	
    FILE *fip;
    
    if((fip = fopen("/etc/config","w")) == NULL){
#ifdef DEBUG        	
	    (void)fprintf( stderr, "Save: Cannot open config file\n" );
#endif
    	return 0;
    }else{
#ifdef DEBUG    	
	    (void) fprintf( stdout, "Save: Success open config file\n" );    	
#endif
        fprintf(fip,"IP='%s'\n", CONFIG.IP);
        fprintf(fip,"NETMASK='%s'\n", CONFIG.NETMASK);
        fprintf(fip,"GATEWAY='%s'\n", CONFIG.GATEWAY);
        fprintf(fip,"DNS_SERVER='%s'\n",CONFIG.DNS_SERVER);
        fprintf(fip,"HOSTNAME='%s'\n", CONFIG.HOSTNAME);
        fprintf(fip,"WORKGROUP='%s'\n", CONFIG.WORKGROUP);        
        fprintf(fip,"HOSTNAME_FULL='%s'\n", CONFIG.HOSTNAME_FULL);
        fprintf(fip,"USERNAME='%s'\n", CONFIG.USERNAME);
        fprintf(fip,"PASSWORD='%s'\n", CONFIG.PASSWORD);
        fprintf(fip,"FTP_MAX='%s'\n",CONFIG.FTP_MAX_UNIT);
        fprintf(fip,"FTP_PORT='%s'\n",CONFIG.FTP_PORT_NUMBER);
        fprintf(fip,"FTP_TIMEOUT='%s'\n",CONFIG.FTP_TIMEOUT);
        fprintf(fip,"FTP_ANONYMITY='%s'\n",CONFIG.FTP_ANONYMITY);
        fprintf(fip,"FTP_ENABLE='%s'\n",CONFIG.FTP_ENABLE);
        fprintf(fip,"DHCP_ENABLE='%s'\n",CONFIG.DHCP_ENABLE);
        fprintf(fip,"LEGAL_IP1='%s'\n",CONFIG.LEGAL_IP[0]);
        fprintf(fip,"LEGAL_IP2='%s'\n",CONFIG.LEGAL_IP[1]);
        fprintf(fip,"LEGAL_IP3='%s'\n",CONFIG.LEGAL_IP[2]);
        fprintf(fip,"LEGAL_IP4='%s'\n",CONFIG.LEGAL_IP[3]);
        fprintf(fip,"LEGAL_IP5='%s'\n",CONFIG.LEGAL_IP[4]);
        fprintf(fip,"LEGAL_IP6='%s'\n",CONFIG.LEGAL_IP[5]);
        fprintf(fip,"LEGAL_IP7='%s'\n",CONFIG.LEGAL_IP[6]);
        fprintf(fip,"LEGAL_IP8='%s'\n",CONFIG.LEGAL_IP[7]);
        fprintf(fip,"LEGAL_IP9='%s'\n",CONFIG.LEGAL_IP[8]);
        fprintf(fip,"LEGAL_IP10='%s'\n",CONFIG.LEGAL_IP[9]);
        fprintf(fip,"IP_SECURITY_MODE='%s'\n",CONFIG.IP_SECURITY_MODE);
        fprintf(fip,"LEGAL_MAC1='%s'\n",CONFIG.LEGAL_MAC[0]);
        fprintf(fip,"LEGAL_MAC2='%s'\n",CONFIG.LEGAL_MAC[1]);
        fprintf(fip,"LEGAL_MAC3='%s'\n",CONFIG.LEGAL_MAC[2]);
        fprintf(fip,"LEGAL_MAC4='%s'\n",CONFIG.LEGAL_MAC[3]);
        fprintf(fip,"LEGAL_MAC5='%s'\n",CONFIG.LEGAL_MAC[4]);
        fprintf(fip,"LEGAL_MAC6='%s'\n",CONFIG.LEGAL_MAC[5]);
        fprintf(fip,"LEGAL_MAC7='%s'\n",CONFIG.LEGAL_MAC[6]);
        fprintf(fip,"LEGAL_MAC8='%s'\n",CONFIG.LEGAL_MAC[7]);
        fprintf(fip,"LEGAL_MAC9='%s'\n",CONFIG.LEGAL_MAC[8]);
        fprintf(fip,"LEGAL_MAC10='%s'\n",CONFIG.LEGAL_MAC[9]);
        fprintf(fip,"MAC_SECURITY_MODE='%s'\n",CONFIG.MAC_SECURITY_MODE);
        fprintf(fip,"TZ='%s'\n",CONFIG.TIME_DIFFER);
        fprintf(fip,"TIME_ZONE='%s'\n",CONFIG.TIME_ZONE);
        fprintf(fip,"TIME_MODE='%s'\n",CONFIG.TIME_MODE);
        fprintf(fip,"TIME_SERVER='%s'\n",CONFIG.TIME_SERVER);
        fprintf(fip,"TIME_VALUE='%s'\n",CONFIG.TIME_VALUE);
        fprintf(fip,"CODE_SET='%s'\n",CONFIG.CODE_SET);
        fprintf(fip,"TCONFIG_FOLDER='%s'\n",CONFIG.TCONFIG_FOLDER);
        fprintf(fip,"TCONFIG_FILENAME='%s'\n",CONFIG.TCONFIG_FILENAME);
        fprintf(fip,"TORRENT_USER='%s'\n",CONFIG.TORRENT_USER);
        fprintf(fip,"TORRENT_ENABLE='%s'\n",CONFIG.TORRENT_ENABLE);
        fprintf(fip,"WEB_ENABLE='%s'\n",CONFIG.WEB_ENABLE);
        fprintf(fip,"WEB_PORT='%s'\n",CONFIG.WEB_PORT);
        fprintf(fip,"WEB_FOLDER='%s'\n",CONFIG.WEB_FOLDER);
        fprintf(fip,"CRON_ENABLE='%s'\n",CONFIG.CRON_ENABLE);
        fprintf(fip,"CRON_START_DAY='%s'\n",CONFIG.CRON_START_DAY);
        fprintf(fip,"CRON_START_HOUR='%s'\n",CONFIG.CRON_START_HOUR);
        fprintf(fip,"CRON_START_MIN='%s'\n",CONFIG.CRON_START_MIN);
        fprintf(fip,"CRON_END_DAY='%s'\n",CONFIG.CRON_END_DAY);
        fprintf(fip,"CRON_END_HOUR='%s'\n",CONFIG.CRON_END_HOUR);
        fprintf(fip,"CRON_END_MIN='%s'\n",CONFIG.CRON_END_MIN);
        fprintf(fip,"ADMIN_PORT='%s'\n",CONFIG.ADMIN_PORT);
        fprintf(fip,"USB_SHARE='%s'\n",CONFIG.USB_SHARE);
        fprintf(fip,"USB_RECYCLE='%s'\n",CONFIG.USB_RECYCLE);
        //===========allen adds to save Printer Setup variable=============        
        fprintf(fip,"PRINTER_ENABLE='%s'\n",CONFIG.SERVER);
        //fprintf(fip,"PRINTER_ENABLE2='%s'\n",CONFIG.SERVER2);        
        //==================================================================
        //==============allen add to save Jimbo frame variable==============
        fprintf(fip,"JUMBO='%s'\n",CONFIG.JUMBO);
        //==================================================================
        fprintf(fip,"SWAP_ENABLE='%s'\n",CONFIG.SWAP_ENABLE);
        //============== allen add to save USB PORT series ============== 
        fprintf(fip,"USB_PORT01='%s'\n",CONFIG.USB_PORT01);
        fprintf(fip,"USB_PORT02='%s'\n",CONFIG.USB_PORT02);
        fprintf(fip,"USB_PORT03='%s'\n",CONFIG.USB_PORT03);
        fprintf(fip,"USB_PORT04='%s'\n",CONFIG.USB_PORT04);
        fprintf(fip,"USB_PORT11='%s'\n",CONFIG.USB_PORT11);
        fprintf(fip,"USB_PORT12='%s'\n",CONFIG.USB_PORT12);
        fprintf(fip,"USB_PORT13='%s'\n",CONFIG.USB_PORT13);
        fprintf(fip,"USB_PORT14='%s'\n",CONFIG.USB_PORT14);
        fprintf(fip,"USB_PORT21='%s'\n",CONFIG.USB_PORT21);
        fprintf(fip,"USB_PORT22='%s'\n",CONFIG.USB_PORT22);
        fprintf(fip,"USB_PORT23='%s'\n",CONFIG.USB_PORT23);
        fprintf(fip,"USB_PORT24='%s'\n",CONFIG.USB_PORT24);
        fprintf(fip,"USB_PORT31='%s'\n",CONFIG.USB_PORT31);
        fprintf(fip,"USB_PORT32='%s'\n",CONFIG.USB_PORT32);
        fprintf(fip,"USB_PORT33='%s'\n",CONFIG.USB_PORT33);
        fprintf(fip,"USB_PORT34='%s'\n",CONFIG.USB_PORT34);
        fprintf(fip,"INITBOOT='%s'\n",CONFIG.INITBOOT);
#if defined(PCI)
		  fprintf(fip,"INTERFACE_SET='%s'\n",CONFIG.INTERFACE_SET);
#endif
        //==================================================================
        //==============allen add to save Jimbo frame variable==============
        //fprintf(fip,"CODE_SET='%s'\n",CONFIG.CODE_PAGE);
        //==================================================================
    }
    fclose(fip);    
	  system("/etc/rc.d/save_config.sh &");	    
    return 1;
}
