#ifndef _SP_INIT_ICONV_H
#define _SP_INIT_ICONV_H


//#define SP_ICONV_INIT_DEBUG
/*
#if      defined(SP_ICONV_INIT_DEBUG)
# define  sp_iconv_initTrace(fmt,arg...)                 printf(fmt,##arg)
# define  sp_iconv_initAssert(cond)                      assert(cond)

# define SP_ICONV_INIT_DUMP(format, arg...) 	sp_iconv_init_dbg(0, (format, ##arg))
# define sp_iconv_init_dbg( level, body )		DEBUG( level, body )
#else
# define  sp_iconv_initTrace(fmt,arg...)                 
# define  sp_iconv_initAssert(cond)                      
# define SP_ICONV_INIT_DUMP(format, arg...) do{      }while(0)
# define SP_ICONV_INIT_DUMP(format, arg...) 	sp_posix_acls_dbg(0, (format, ##arg))
# define sp_iconv_init_dbg( level, body )		DEBUG( level, body )
#endif
*/
/*
# define SP_ICONV_INIT_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f) ; \
}while(0)
*/

#define  sp_iconv_initTrace(fmt,arg...)   
#define SP_ICONV_INIT_DUMP(format, arg...) do{      }while(0)

#define FILE_CP		"ntx_chset.h"
#define FILE_CP1	"ntx_chset_1.h"

char *ntx_chset_file[]={
	FILE_CP,
	FILE_CP1,
};

struct iconv_init_file {
	char* file;
	//int grain; 	// 0 takes up S8, 1 takes up U8, 2 takes up S16, 3 takes up U16
	unsigned char grain; 	// 0 takes up S8, 1 takes up U8, 2 takes up S16, 3 takes up U16
	int size;
	void* charset;
	/*
	void* charset;
	unsigned char* uchset;
	short* shset;
	unsigned short* ushset;
	*/
};

//armscii_8.h
extern unsigned short armscii_8_2uni[96];
extern unsigned char armscii_8_page05[96];
//big5.h
extern unsigned short big5_2uni_pagea1 [6121];
extern unsigned short big5_2uni_pagec9 [7652];
extern unsigned short big5_2charset [13703];
//cjk_variants.h
extern unsigned short cjk_variants [12038];
extern short cjk_variants_indx [0x5200];
//cns11643_1.h
extern unsigned short cns11643_1_2uni_page21 [500];
extern unsigned short cns11643_1_2uni_page44 [5401];
//cns11643_2.h
extern unsigned short cns11643_2_2uni_page21 [7650];
//cns11643_3.h
extern unsigned short cns11643_3_2uni_page21 [6148];
extern unsigned short cns11643_3_2uni_page64 [292];
//cns11643_4a.h
extern unsigned short cns11643_4a_2uni_page21 [2914];
//cns11643_4b.h
extern unsigned short cns11643_4b_2uni_page40 [4384];
//cns11643_5.h
extern unsigned short cns11643_5_2uni_page21 [8603];
//cns11643_6.h
extern unsigned short cns11643_6_2uni_page21 [6388];
//cns11643_7.h
extern unsigned short cns11643_7_2uni_page21 [6539];
//cns11643_15.h
extern unsigned short cns11643_15_2uni_page21 [7169];
//cns11643_inv.h
extern unsigned char cns11643_inv_2charset [3*55441];
//cp1133.h
extern unsigned short cp1133_2uni_1 [64];
extern unsigned char cp1133_page0e [96];
//cp1250.h
extern unsigned short cp1250_2uni [128];
extern unsigned char cp1250_page00 [224];
//cp1251.h
extern unsigned short cp1251_2uni [128];
extern unsigned char cp1251_page04 [152];
//cp1253.h
extern unsigned short cp1253_2uni [128];
extern unsigned char cp1253_page03 [80];
//cp1255.h
extern unsigned short cp1255_2uni [128];
extern unsigned char cp1255_page00 [88];
//cp1256.h
extern unsigned short cp1256_2uni [128];
extern unsigned char cp1256_page00 [96];
//cp1257.h
extern unsigned short cp1257_2uni [128];
extern unsigned char cp1257_page00 [224];
//cp1258.h
extern unsigned short cp1258_2uni [128];
extern unsigned char cp1258_page00 [88];
extern unsigned char cp1258_page01 [104];
//iso8859_2.h
extern unsigned short iso8859_2_2uni [96];
extern unsigned char iso8859_2_page00 [224];
//iso8859_3.h
extern unsigned short iso8859_3_2uni [96];
extern unsigned char iso8859_3_page00 [96];
extern unsigned char iso8859_3_page01 [120];
//iso8859_4.h
extern unsigned short iso8859_4_2uni [96];
extern unsigned char iso8859_4_page00 [224];
//iso8859_5.h
extern unsigned short iso8859_5_2uni [96];
extern unsigned char iso8859_5_page04 [96];
//iso8859_6.h
extern unsigned short iso8859_6_2uni [96];
extern unsigned char iso8859_6_page06 [80];
//iso8859_7.h
extern unsigned short iso8859_7_2uni [96];
extern unsigned char iso8859_7_page03[80];
//iso8859_8.h
extern unsigned short iso8859_8_2uni [96];
extern unsigned char iso8859_8_page00 [88];
//iso8859_9.h
extern unsigned short iso8859_9_2uni [48];
//iso8859_10.h
extern unsigned short iso8859_10_2uni [96];
extern unsigned char iso8859_10_page00 [224];
//iso8859_13.h
extern unsigned short iso8859_13_2uni [96];
extern unsigned char iso8859_13_page00 [224];
//iso8859_14.h
extern unsigned short iso8859_14_2uni [96];
extern unsigned char iso8859_14_page00 [96];
extern unsigned char iso8859_14_page1e_0 [136];
//iso8859_16.h
extern unsigned short iso8859_16_2uni [96];
extern unsigned char iso8859_16_page00 [224];
//koi8_r.h
extern unsigned short koi8_r_2uni [128];
extern unsigned char koi8_r_page00 [88];
extern unsigned char koi8_r_page04 [88];
extern unsigned char koi8_r_page22 [80];
//koi8_ru.h
extern unsigned short koi8_ru_2uni [128];
extern unsigned char koi8_ru_page00 [88];
extern unsigned char koi8_ru_page04 [152];
extern unsigned char koi8_ru_page22 [80];
//koi8_u.h
extern unsigned short koi8_u_2uni [128];
extern unsigned char koi8_u_page00 [88];
extern unsigned char koi8_u_page04 [152];
extern unsigned char koi8_u_page22 [80];
//koi8_t.h
unsigned short koi8_t_2uni [128];
unsigned char koi8_t_page04 [240];



//cp932ext.h
extern unsigned short cp932ext_2uni_page87 [92];
extern unsigned short cp932ext_2uni_pageed [376];
extern unsigned short cp932ext_2uni_pagefa [388];
extern unsigned short cp932ext_2charset [457];
//cp950.h
extern unsigned short cp950_2uni_pagea1[314];
//gb2312.h
extern unsigned short gb2312_2uni_page21 [831];
extern unsigned short gb2312_2uni_page30 [6768];
extern unsigned short gb2312_2charset [7445];
//gbkext_inv.h
extern unsigned short gbkext_inv_2charset [14313];
//gbkext1.h
extern unsigned short gbkext1_2uni_page81 [6080];
//gbkext2.h
extern unsigned short gbkext2_2uni_pagea8 [8272];
//hkscs.h
extern unsigned short hkscs_2uni_page88 [627];
extern unsigned short hkscs_2uni_page8d [3140];
extern unsigned short hkscs_2uni_pagec6 [471];
extern unsigned short hkscs_2uni_pagef9 [942];
extern unsigned short hkscs_2charset [4702];
//isoir165ext.h
extern unsigned short isoir165ext_2uni_page2b [470];
extern unsigned short isoir165ext_2uni_page7a [470];
extern unsigned short isoir165ext_2charset [876];
//jisx0208.h
extern unsigned short jisx0208_2uni_page21 [690];
extern unsigned short jisx0208_2uni_page30 [6398];
extern unsigned short jisx0208_2charset [6879];
//jisx0212.h
extern unsigned short jisx0212_2uni_page22 [81];
extern unsigned short jisx0212_2uni_page26 [188];
extern unsigned short jisx0212_2uni_page29 [275];
extern unsigned short jisx0212_2uni_page30 [5801];
extern unsigned short jisx0212_2charset [6067];
//ksc5601.h
extern unsigned short ksc5601_2uni_page21 [1115];
extern unsigned short ksc5601_2uni_page30 [2350];
extern unsigned short ksc5601_2uni_page4a [4888];
extern unsigned short ksc5601_2charset [8226];
//translit.h
extern short translit_page00 [344];
extern short translit_page02_1 [40];
extern short translit_page03 [48];
extern short translit_page1e [160];
extern short translit_page20 [88];
extern short translit_page21 [216];
extern short translit_page22 [96];
extern short translit_page22_4 [48];
extern short translit_page24 [240];
extern short translit_page25 [64];
extern short translit_page2f [216];
extern short translit_page30 [248];
extern short translit_page31 [96];
extern short translit_page31_5 [528];
extern short translit_pagef9 [368];
extern short translit_pagefb [80];
extern short translit_pagefe [40];
extern short translit_pageff [240];
extern short translit_page1d4 [1024];
extern short translit_page2f8 [544];
//uhc_1.h
extern unsigned short uhc_1_2uni_main_page81 [64];
extern unsigned char uhc_1_2uni_page81 [5696];
extern unsigned short uhc_1_2charset_main [45];
extern unsigned char uhc_1_2charset [5696];
//uhc_2.h
extern unsigned short uhc_2_2uni_main_pagea1 [76];
extern unsigned char uhc_2_2uni_pagea1 [3126];
extern unsigned short uhc_2_2charset_main [49];
extern unsigned char uhc_2_2charset [3126];
//viscii.h
extern unsigned short viscii_2uni_2 [128];
extern unsigned char viscii_page00 [64+184];
extern unsigned char viscii_page1e [96];


struct iconv_init_file iconv_file[]=
{
	//armscii_8.h
	{"armscii_8_2uni", 3, 96, armscii_8_2uni },				//0
	{"armscii_8_page05", 1, 96, armscii_8_page05 },
	
	//big5.h
	{"big5_2uni_pagea1", 3, 6121, big5_2uni_pagea1 },
	{"big5_2uni_pagec9", 3, 7652, big5_2uni_pagec9 },
	{"big5_2charset", 3, 13703, big5_2charset },
	//cjk_variants.h
	{"cjk_variants", 3, 12038, cjk_variants },
	{"cjk_variants_indx", 2, 0x5200, cjk_variants_indx },
	//cns11643_1.h
	{"cns11643_1_2uni_page21", 3, 500, cns11643_1_2uni_page21 },
	{"cns11643_1_2uni_page44", 3, 5401, cns11643_1_2uni_page44 },
	//cns11643_2.h
	{"cns11643_2_2uni_page21", 3, 7650, cns11643_2_2uni_page21 },
	//cns11643_3.h
	{"cns11643_3_2uni_page21", 3, 6148, cns11643_3_2uni_page21 },
	{"cns11643_3_2uni_page64", 3, 292, cns11643_3_2uni_page64 },
	//cns11643_4a.h
	{"cns11643_4a_2uni_page21", 3, 2914, cns11643_4a_2uni_page21 },
	//cns11643_4b.h
	{"cns11643_4b_2uni_page40", 3, 4384, cns11643_4b_2uni_page40 },
	//cns11643_5.h
	{"cns11643_5_2uni_page21", 3, 8603, cns11643_5_2uni_page21 },
	//cns11643_6.h
	{"cns11643_6_2uni_page21", 3, 6388, cns11643_6_2uni_page21 },
	//cns11643_7.h
	{"cns11643_7_2uni_page21", 3, 6539, cns11643_7_2uni_page21 },
	//cns11643_15.h
	{"cns11643_15_2uni_page21", 3, 7169, cns11643_15_2uni_page21 },
	//cns11643_inv.h
	{"cns11643_inv_2charset", 1, 3*55441, cns11643_inv_2charset },
	//cp1250.h
	{"cp1133_2uni_1", 3, 64, cp1133_2uni_1 },
	{"cp1133_page0e", 1, 96, cp1133_page0e },
	//cp1250.h
	{"cp1250_2uni", 3, 128, cp1250_2uni },
	{"cp1250_page00", 1, 224, cp1250_page00 },
	//cp1251.h
	{"cp1251_2uni", 3, 128, cp1251_2uni },
	{"cp1251_page04", 1, 152, cp1251_page04 },
	//cp1253.h
	{"cp1253_2uni", 3, 128, cp1253_2uni },
	{"cp1253_page03", 1, 80, cp1253_page03 },
	//cp1255.h
	{"cp1255_2uni", 3, 128, cp1255_2uni },
	{"cp1255_page00", 1, 88, cp1255_page00 },
	//cp1256.h
	{"cp1256_2uni", 3, 128, cp1256_2uni },
	{"cp1256_page00", 1, 96, cp1256_page00 },
	//cp1257.h
	{"cp1257_2uni", 3, 128, cp1257_2uni },
	{"cp1257_page00", 1, 224, cp1257_page00 },
	//cp1258.h
	{"cp1258_2uni", 3, 128, cp1258_2uni },
	{"cp1258_page00", 1, 88, cp1258_page00 },
	{"cp1258_page01", 1, 104, cp1258_page01 },
	//iso8859_2.h
	{"iso8859_2_2uni", 3, 96, iso8859_2_2uni },
	{"iso8859_2_page00", 1, 224, iso8859_2_page00 },
	//iso8859_3.h
	{"iso8859_3_2uni", 3, 96, iso8859_3_2uni },
	{"iso8859_3_page00", 1, 96, iso8859_3_page00 },
	{"iso8859_3_page01", 1, 120, iso8859_3_page01 },
	//iso8859_4.h
	{"iso8859_4_2uni", 3, 96, iso8859_4_2uni },
	{"iso8859_4_page00", 1, 224, iso8859_4_page00 },
	//iso8859_5.h
	{"iso8859_5_2uni", 3, 96, iso8859_5_2uni },
	{"iso8859_5_page04", 1, 96, iso8859_5_page04 },
	//iso8859_6.h
	{"iso8859_6_2uni", 3, 96, iso8859_6_2uni },
	{"iso8859_6_page06", 1, 80, iso8859_6_page06 },
	//iso8859_7.h
	{"iso8859_7_2uni", 3, 96, iso8859_7_2uni },
	{"iso8859_7_page03", 1, 80, iso8859_7_page03 },
	//iso8859_8.h
	{"iso8859_8_2uni", 3, 96, iso8859_8_2uni },
	{"iso8859_8_page00", 1, 88, iso8859_8_page00 },
	//iso8859_9.h
	{"iso8859_9_2uni", 3, 48, iso8859_9_2uni },
	//iso8859_10.h
	{"iso8859_10_2uni", 3, 96, iso8859_10_2uni },
	{"iso8859_10_page00", 1, 224, iso8859_10_page00 },
	//iso8859_13.h
	{"iso8859_13_2uni", 3, 96, iso8859_13_2uni },
	{"iso8859_13_page00", 1, 224, iso8859_13_page00 },
	//iso8859_14.h
	{"iso8859_14_2uni", 3, 96, iso8859_14_2uni },
	{"iso8859_14_page00", 1, 96, iso8859_14_page00 },
	{"iso8859_14_page1e_0", 1, 136, iso8859_14_page1e_0 },
	//iso8859_16.h
	{"iso8859_16_2uni", 3, 96, iso8859_16_2uni },
	{"iso8859_16_page00", 1, 224, iso8859_16_page00 },
	//koi8_r.h
	{"koi8_r_2uni", 3, 128, koi8_r_2uni },
	{"koi8_r_page00", 1, 88, koi8_r_page00 },
	{"koi8_r_page04", 1, 88, koi8_r_page04 },
	{"koi8_r_page22", 1, 80, koi8_r_page22 },
	//koi8_ru.h
	{"koi8_ru_2uni", 3, 128, koi8_ru_2uni },
	{"koi8_ru_page00", 1, 88, koi8_ru_page00 },
	{"koi8_ru_page04", 1, 152, koi8_ru_page04 },
	{"koi8_ru_page22", 1, 80, koi8_ru_page22 },
	//koi8_u.h
	{"koi8_u_2uni", 3, 128, koi8_u_2uni },
	{"koi8_u_page00", 1, 88, koi8_u_page00 },
	{"koi8_u_page04", 1, 152, koi8_u_page04 },
	{"koi8_u_page22", 1, 80, koi8_u_page22 },
	//koi8_t.h
	{"koi8_t_2uni", 3, 128, koi8_t_2uni },
	{"koi8_t_page04", 1, 240, koi8_t_page04 },

	


	//cp932ext.h
	{"cp932ext_2uni_page87", 3, 92, cp932ext_2uni_page87 },
	{"cp932ext_2uni_pageed", 3, 376, cp932ext_2uni_pageed },
	{"cp932ext_2uni_pagefa", 3, 388, cp932ext_2uni_pagefa },
	{"cp932ext_2charset", 3, 457, cp932ext_2charset },
	//cp950.h
	{"cp950_2uni_pagea1", 3, 314, cp950_2uni_pagea1 },
	//gb2312.h
	{"gb2312_2uni_page21", 3, 831, gb2312_2uni_page21 },
	{"gb2312_2uni_page30", 3, 6768, gb2312_2uni_page30 },
	{"gb2312_2charset", 3, 7445, gb2312_2charset },
	//gbkext_inv.h
	{"gbkext_inv_2charset", 3, 14313, gbkext_inv_2charset },
	//gbkext1.h
	{"gbkext1_2uni_page81", 3, 6080, gbkext1_2uni_page81 },
	//gbkext2.h
	{"gbkext2_2uni_pagea8", 3, 8272, gbkext2_2uni_pagea8 },
	//hkscs.h
	{"hkscs_2uni_page88", 3, 627, hkscs_2uni_page88 },
	{"hkscs_2uni_page8d", 3, 3140, hkscs_2uni_page8d },
	{"hkscs_2uni_pagec6", 3, 471, hkscs_2uni_pagec6 },
	{"hkscs_2uni_pagef9", 3, 942, hkscs_2uni_pagef9 },
	{"hkscs_2charset", 3, 4702, hkscs_2charset },
	//isoir165ext.h
	{"isoir165ext_2uni_page2b", 3, 470, isoir165ext_2uni_page2b },
	{"isoir165ext_2uni_page7a", 3, 470, isoir165ext_2uni_page7a },
	{"isoir165ext_2charset", 3, 876, isoir165ext_2charset },
	//jisx0208.h	
	{"jisx0208_2uni_page21", 3, 690, jisx0208_2uni_page21 },
	{"jisx0208_2uni_page30", 3, 6398, jisx0208_2uni_page30 },
	{"jisx0208_2charset", 3, 6879, jisx0208_2charset },
	//jisx0212.h
	{"jisx0212_2uni_page22", 3, 81, jisx0212_2uni_page22 },
	{"jisx0212_2uni_page26", 3, 188, jisx0212_2uni_page26 },
	{"jisx0212_2uni_page29", 3, 275, jisx0212_2uni_page29 },
	{"jisx0212_2uni_page30", 3, 5801, jisx0212_2uni_page30 },
	{"jisx0212_2charset", 3, 6067, jisx0212_2charset },
	//ksc5601.h
	{"ksc5601_2uni_page21", 3, 1115, ksc5601_2uni_page21 },
	{"ksc5601_2uni_page30", 3, 2350, ksc5601_2uni_page30 },
	{"ksc5601_2uni_page4a", 3, 4888, ksc5601_2uni_page4a },
	{"ksc5601_2charset", 3, 8226, ksc5601_2charset },
	//translit.h
	{"translit_page00", 2, 344, translit_page00 },
	{"translit_page02_1", 2, 40, translit_page02_1 },
	{"translit_page03", 2, 48, translit_page03 },
	{"translit_page1e", 2, 160, translit_page1e },
	{"translit_page20", 2, 88, translit_page20 },
	{"translit_page21", 2, 216, translit_page21 },
	{"translit_page22", 2, 96, translit_page22 },
	{"translit_page22_4", 2, 48, translit_page22_4 },
	{"translit_page24", 2, 240, translit_page24 },
	{"translit_page25", 2, 64, translit_page25 },
	{"translit_page2f", 2, 216, translit_page2f },
	{"translit_page30", 2, 248, translit_page30 },
	{"translit_page31", 2, 96, translit_page31 },
	{"translit_page31_5", 2, 528, translit_page31_5 },
	{"translit_pagef9", 2, 368, translit_pagef9 },
	{"translit_pagefb", 2, 80, translit_pagefb },
	{"translit_pagefe", 2, 40, translit_pagefe },
	{"translit_pageff", 2, 240, translit_pageff },
	{"translit_page1d4", 2, 1024, translit_page1d4 },
	{"translit_page2f8", 2, 544, translit_page2f8 },
	//uhc_1.h
	{"uhc_1_2uni_main_page81", 3, 64, uhc_1_2uni_main_page81 },
	{"uhc_1_2uni_page81", 1, 5696, uhc_1_2uni_page81 },
	{"uhc_1_2charset_main", 3, 45, uhc_1_2charset_main },
	{"uhc_1_2charset", 1, 5696, uhc_1_2charset },
	//uhc_2.h
	{"uhc_2_2uni_main_pagea1", 3, 76, uhc_2_2uni_main_pagea1 },
	{"uhc_2_2uni_pagea1", 1, 3126, uhc_2_2uni_pagea1 },
	{"uhc_2_2charset_main", 3, 49, uhc_2_2charset_main },
	{"uhc_2_2charset", 1, 3126, uhc_2_2charset },
	//viscii.h
	{"viscii_2uni_2", 3, 128, viscii_2uni_2 },
	{"viscii_page00", 1, (64+184), viscii_page00 },
	{"viscii_page1e", 1, 96, viscii_page1e },
	


};

#define ICONV_INIT_FILE_COUNT 	(sizeof(iconv_file)/sizeof(iconv_file[0]))












#endif //ifndef _SP_INIT_ICONV_H
