#ifndef _SP_SAMBA_DBG_H
#define _SP_SAMBA_DBG_H

//#include "sp_samba_dbg.h"

/*
* Enable this for global debug information
*/
#define SP_SAMBA_DEBUG	

#if      defined(SP_SAMBA_DEBUG)
# define sp_sambaTrace(fmt,arg...)                 printf(fmt,##arg)
# define sp_sambaAssert(cond)                      assert(cond)
# define SAMBA_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
//# define SAMBA_DUMP(format, arg...) 			sp_smbd_num_dbg(0, (format, ##arg))
# define sp_smbd_num_dbg( level, body )				DEBUG( level, body )
#else
# define  sp_sambaTrace(format, args...)
# define  sp_sambaAssert(cond)
# define SAMBA_DUMP(format, arg...)
# define  sp_smbd_num_dbg( level, body )
# define  sp_smbd_numAssert(cond)
#endif


#endif //_SP_SAMBA_DBG_H
