#ifndef _SP_LIB_DBG_H
#define _SP_LIB_DBG_H

#include "sp_samba_dbg.h"
/*
#define SP_UTIL_DEBUG
#define SP_UTIL_SOCK_DEBUG
#define SP_USERNAME_DEBUG
#define SP_HASH_DEBUG
#define SP_TALLOC_DEBUG
*/
/*
#define SP_UTIL_DEBUG
//#define SP_HASH_DEBUG
//#define SP_TALLOC_DEBUG
//#define SP_SMBRUN_DEBUG
//#define SP_USERNAME_DEBUG
*/

/*
//#define SP_UTIL_DEBUG
//#define SP_PIDFILE_DEBUG
//#define SP_DEBUG_DEBUG
//#define SP_MESSAGE_DEBUG
#define SP_SYSTEM_DEBUG
#define SP_UTIL_SEC_DEBUG
*/
//#define SP_CHARCNV_DEBUG
//#define SP_UTIL_PW_DEBUG
//#define SP_SYSTEM_DEBUG
//#define SP_SMBD_NUM_DEBUG
//#define SP_SIGNAL_DEBUG
//#define SP_UTIL_FILE_DEBUG

#if      defined(SP_UTIL_DEBUG)
	#define  sp_utilTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_utilAssert(cond)                      assert(cond)
	#define UTIL_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	# define  sp_utilTrace(format, args...)
	# define  sp_utilAssert(cond)
	# define UTIL_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_UTIL_SOCK_DEBUG)
	#define  sp_util_sockTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_util_sockAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_util_sockTrace(format, args...)
	#define  sp_util_sockAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_USERNAME_DEBUG)
	#define USERNAME_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define USERNAME_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_HASH_DEBUG)
	#define  sp_util_sockTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_util_sockAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_util_sockTrace(format, args...)
	#define  sp_util_sockAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_TALLOC_DEBUG)
	#define  sp_util_sockTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_util_sockAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_util_sockTrace(format, args...)
	#define  sp_util_sockAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SMBRUN_DEBUG)
	#define  sp_smbrunTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_smbrunAssert(cond)                      assert(cond)
	#define SMBRUN_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_smbrunTrace(format, args...)
	#define  sp_smbrunAssert(cond)
	#define SMBRUN_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_PIDFILE_DEBUG)
	#define PIDFILE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define PIDFILE_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_DEBUG_DEBUG)
	#define DEBUG_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define DEBUG_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_MESSAGE_DEBUG)
	#define MESSAGE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define MESSAGE_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SYSTEM_DEBUG)

	#define SYSTEM_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)

//# define SYSTEM_DUMP(format, arg...) 		sp_system_dbg(0, (format, ##arg))
# define sp_system_dbg( level, body )		DEBUG( level, body )
#else
	#define SYSTEM_DUMP(format, arg...) do{      }while(0)
# define sp_system_dbg( level, body )		
#endif

#if      defined(SP_UTIL_SEC_DEBUG)
/*
	#define SYSTEM_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define UTIL_SEC_DUMP(format, arg...) 		sp_util_sec_dbg(0, (format, ##arg))
# define sp_util_sec_dbg( level, body )		DEBUG( level, body )
#else
	#define UTIL_SEC_DUMP(format, arg...) do{      }while(0)
# define sp_util_sec_dbg( level, body )		
#endif

#if      defined(SP_CHARCNV_DEBUG)
	#define  sp_charcnvTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_charcnvAssert(cond)                      assert(cond)
/*	
	#define CHARCNV_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define CHARCNV_DUMP(format, arg...) 			sp_charcnv_dbg(0, (format, ##arg))
# define sp_charcnv_dbg( level, body )			DEBUG( level, body )
#else
# define  sp_charcnvTrace(format, args...)
# define sp_charcnv_dbg( level, body )
# define  sp_charcnvAssert(cond)
# define CHARCNV_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_UTIL_PW_DEBUG)
	#define  sp_util_pwTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_util_pwAssert(cond)                      assert(cond)

# define UTIL_PW_DUMP(format, arg...) 			sp_util_pw_dbg(0, (format, ##arg))
# define sp_util_pw_dbg( level, body )			DEBUG( level, body )
#else
# define  sp_util_pw_dbg(format, args...)
# define  sp_util_pwAssert(cond)
# define UTIL_PW_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SMBD_NUM_DEBUG)
	#define  sp_Trace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_smbd_numAssert(cond)             	assert(cond)
	
#define SP_SMBD_NUM_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)

//# define SP_SMBD_NUM_DUMP(format, arg...) 			sp_smbd_num_dbg(0, (format, ##arg))
# define sp_smbd_num_dbg( level, body )				DEBUG( level, body )
#else
# define  sp_smbd_num_dbg( level, body )
# define  sp_smbd_numAssert(cond)
# define SP_SMBD_NUM_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SIGNAL_DEBUG)
	#define  sp_signalTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_signalAssert(cond)             	assert(cond)
	
#define SP_SIGNAL_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)

//# define SP_SIGNAL_DUMP(format, arg...) 			sp_signal_dbg(0, (format, ##arg))
# define sp_signal_dbg( level, body )				DEBUG( level, body )
#else
# define  sp_signal_dbg( level, body )
# define  sp_signalAssert(cond)
# define SP_SIGNAL_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_UTIL_FILE_DEBUG)
	#define  sp_util_fileTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_util_fileAssert(cond)             	assert(cond)
	
#define SP_UTIL_FILE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)

//# define SP_UTIL_FILE_DUMP(format, arg...) 			sp_util_file_dbg(0, (format, ##arg))
# define sp_util_file_dbg( level, body )				DEBUG( level, body )
#else
# define  sp_util_file_dbg( level, body )
# define  sp_util_fileAssert(cond)
# define SP_UTIL_FILE_DUMP(format, arg...) do{      }while(0)
#endif

#endif //_SP_LIB_DBG_H
