#ifndef _SP_AUTH_DBG_H
#define _SP_AUTH_DBG_H

//#include "sp_samba_dbg.h"
/*
*/

/*
#define SP_AUTH_UTIL_DEBUG
#define SP_AUTH_DEBUG
*/
#define SP_AUTH_DEBUG
#define SP_AUTH_NTLMSSP_DEBUG
#define SP_AUTH_SAM_DEBUG
#define SP_AUTH_BUILTIN_DEBUG

#if      defined(SP_AUTH_UTIL_DEBUG)
/*
	#define TDB_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
//#define TDB_DUMP(format, arg...) 		sp_tdb_dbg(0, (format, ##arg))
# define sp_auth_util_dbg( level, body )		DEBUG( level, body )

#else
	//#define TDB_DUMP(format, arg...) do{      }while(0)
# define sp_auth_util_dbg( level, body )		
#endif


#if      defined(SP_AUTH_DEBUG)
/*
	#define TDB_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
//#define TDB_DUMP(format, arg...) 		sp_tdb_dbg(0, (format, ##arg))
# define sp_auth_dbg( level, body )		DEBUG( level, body )

#else
	//#define TDB_DUMP(format, arg...) do{      }while(0)
# define sp_auth_dbg( level, body )		
#endif


#if      defined(SP_AUTH_NTLMSSP_DEBUG)
/*
	#define AUTH_NTLMSSP_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define AUTH_NTLMSSP_DUMP(format, arg...) 		sp_suth_ntlmssp_dbg(0, (format, ##arg))
# define sp_suth_ntlmssp_dbg( level, body )		DEBUG( level, body )
#else
	//#define AUTH_NTLMSSP_DUMP(format, arg...) do{      }while(0)
# define AUTH_NTLMSSP_DUMP(format, arg...) 		
# define sp_suth_ntlmssp_dbg( level, body )		
#endif

#if      defined(SP_AUTH_SAM_DEBUG)
/*
	#define AUTH_SAM_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define AUTH_SAM_DUMP(format, arg...) 		sp_auth_sam_dbg(0, (format, ##arg))
# define sp_auth_sam_dbg( level, body )		DEBUG( level, body )
#else
	//#define AUTH_SAM_DUMP(format, arg...) do{      }while(0)
# define AUTH_SAM_DUMP(format, arg...) 		
# define sp_auth_sam_dbg( level, body )		
#endif

#if      defined(SP_AUTH_BUILTIN_DEBUG)
/*
	#define AUTH_BUILTIN_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define AUTH_BUILTIN_DUMP(format, arg...) 		sp_auth_builtin_dbg(0, (format, ##arg))
# define sp_auth_builtin_dbg( level, body )		DEBUG( level, body )
#else
	//#define AUTH_SAM_DUMP(format, arg...) do{      }while(0)
# define AUTH_BUILTIN_DUMP(format, arg...) 		
# define sp_auth_builtin_dbg( level, body )		
#endif
#endif //_SP_AUTH_DBG_H
