#ifndef _SP_LIB_DBG_H
#define _SP_LIB_DBG_H

//#include "sp_samba_dbg.h"

#define SP_CLISPNEGO_DEBUG
#define SP_NTLMSSP_DEBUG
#define SP_NTLMSSP_PARSE_DEBUG
#define SP_ASN1_DEBUG



#if      defined(SP_CLISPNEGO_DEBUG)
	#define  sp_clispnegoTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_clispnegoAssert(cond)                      assert(cond)
/*	
	#define CLISPNEGO_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define CLISPNEGO_DUMP(format, arg...) 			sp_clispnego_dbg(0, (format, ##arg))
# define sp_clispnego_dbg( level, body )			DEBUG( level, body )
#else
# define  sp_clispnegoTrace(format, args...)
# define  sp_clispnegoAssert(cond)
# define CLISPNEGO_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_NTLMSSP_DEBUG)
	#define  sp_ntlmsspTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_ntlmsspAssert(cond)                      assert(cond)
/*	
	#define NTLMSSP_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define NTLMSSP_DUMP(format, arg...) 			sp_ntlmssp_dbg(0, (format, ##arg))
# define sp_ntlmssp_dbg( level, body )			DEBUG( level, body )
#else
# define  sp_ntlmsspTrace(format, args...)
# define  sp_ntlmsspAssert(cond)
# define NTLMSSP_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_NTLMSSP_PARSE_DEBUG)
/*	
	#define NTLMSSP_PARSE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define NTLMSSP_PARSE_DUMP(format, arg...) 			sp_ntlmssp_parse_dbg(0, (format, ##arg))
# define sp_ntlmssp_parse_dbg( level, body )			DEBUG( level, body )
#else
# define  sp_ntlmssp_parse_dbg(format, args...)
# define NTLMSSP_PARSE_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_ASN1_DEBUG)
# define ASN1_DUMP(format, arg...) 			sp_asn1_dbg(0, (format, ##arg))
# define sp_asn1_dbg( level, body )			DEBUG( level, body )
#else
# define  sp_asn1_dbg(format, args...)
# define ASN1_DUMP(format, arg...) do{      }while(0)
#endif


#endif //_SP_LIB_DBG_H
