#ifndef _SP_LOCKING_DBG_H
#define _SP_LOCKING_DBG_H

//#include "sp_samba_dbg.h"

//#define SP_LOCKING_DEBUG


#if      defined(SP_LOCKING_DEBUG)
	#define  sp_lockingTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_lockingAssert(cond)                      assert(cond)
/*	
	#define LOCKING_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define LOCKING_DUMP(format, arg...) 		sp_locking_dbg(0, (format, ##arg))
# define sp_locking_dbg( level, body )		DEBUG( level, body )
#else
	#define  sp_lockingTrace(format, args...)
	#define  sp_lockingAssert(cond)
	#define LOCKING_DUMP(format, arg...) do{      }while(0)
# define sp_locking_dbg( level, body )		
#endif




#endif //_SP_LOCKING_DBG_H
