#ifndef _SP_PASSDB_DBG_H
#define _SP_PASSDB_DBG_H

//#include "sp_samba_dbg.h"
/*
//#define SP_SECRETS_DEBUG
#define SP_PDB_GET_SET_DEBUG
#define SP_LOOKUP_SID_DEBUG
*/

#if      defined(SP_SECRETS_DEBUG)
	#define  sp_secretsTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_secretsAssert(cond)                      assert(cond)
/*	
	#define SECRETS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define SECRETS_DUMP(format, arg...) 		sp_secrets_dbg(0, (format, ##arg))
# define sp_secrets_dbg( level, body )		DEBUG( level, body )
#else
	#define  sp_secretsTrace(format, args...)
	#define  sp_secretsAssert(cond)
	#define SECRETS_DUMP(format, arg...) do{      }while(0)
# define sp_secrets_dbg( level, body )		
#endif

//#define SP_PDB_GET_SET_DEBUG
#if      defined(SP_PDB_GET_SET_DEBUG)
	#define  sp_secretsTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_secretsAssert(cond)                      assert(cond)
/*	
	#define SECRETS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define PDB_GET_SET_DUMP(format, arg...) 		sp_secrets_dbg(0, (format, ##arg))
# define sp_pdb_get_set_dbg( level, body )		DEBUG( level, body )
#else
	#define  sp_secretsTrace(format, args...)
	#define  sp_secretsAssert(cond)
	#define PDB_GET_SET_DUMP(format, arg...) do{      }while(0)
# define sp_pdb_get_set_dbg( level, body )		
#endif

//#define SP_LOOKUP_SID_DEBUG
#if      defined(SP_LOOKUP_SID_DEBUG)
	#define  sp_secretsTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_secretsAssert(cond)                      assert(cond)
/*	
	#define LOOKUP_SID_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define LOOKUP_SID_DUMP(format, arg...) 		sp_lookup_sid_dbg(0, (format, ##arg))
# define sp_lookup_sid_dbg( level, body )		DEBUG( level, body )
#else
	#define  sp_secretsTrace(format, args...)
	#define  sp_secretsAssert(cond)
	#define LOOKUP_SID_DUMP(format, arg...) do{      }while(0)
# define sp_lookup_sid_dbg( level, body )		
#endif


#endif //_SP_PASSDB_DBG_H
