#ifndef _SP_RPC_SERVER_DBG_H
#define _SP_RPC_SERVER_DBG_H

//#include "sp_samba_dbg.h"

//#define SP_SRV_SRVSVC_DEBUG


#if      defined(SP_SRV_SRVSVC_DEBUG)
	#define  sp_srv_srvsvcTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_srv_srvsvcAssert(cond)                      assert(cond)
/*	
	#define SRV_SRVSVC_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define SRV_SRVSVC_DUMP(format, arg...) 		sp_srv_srvsvc_dbg(0, (format, ##arg))
# define sp_srv_srvsvc_dbg( level, body )		DEBUG( level, body )
#else
	#define  sp_srv_srvsvcTrace(format, args...)
	#define  sp_srv_srvsvcAssert(cond)
	#define SRV_SRVSVC_DUMP(format, arg...) do{      }while(0)
# define sp_srv_srvsvc_dbg( level, body )		
#endif




#endif //_SP_RPC_SERVER_DBG_H
