#ifndef _SP_LIB_DBG_H
#define _SP_LIB_DBG_H

//#include "sp_samba_dbg.h"
/*
*/
//#define SP_TDB_DEBUG
//#define SP_TDBTORTURE_DEBUG
//#define SP_TDBTEST_DEBUG
//#define SP_TDBUTIL_DEBUG
//#define SP_SPINLOCK_DEBUG

#if      defined(SP_TDB_DEBUG)
/*
	#define TDB_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
#define TDB_DUMP(format, arg...) 		sp_tdb_dbg(0, (format, ##arg))
# define sp_tdb_dbg( level, body )		DEBUG( level, body )

#else
	#define TDB_DUMP(format, arg...) do{      }while(0)
# define sp_tdb_dbg( level, body )		
#endif


#if      defined(SP_TDBUTIL_DEBUG)
/*
	#define TDBUTIL_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
#define TDBUTIL_DUMP(format, arg...) 		sp_tdbutil_dbg(0, (format, ##arg))
# define sp_tdbutil_dbg( level, body )		DEBUG( level, body )

#else
	#define TDBUTIL_DUMP(format, arg...) do{      }while(0)
# define sp_tdbutil_dbg( level, body )		
#endif


#if      defined(SP_TDBTORTURE_DEBUG)
	#define TDBTORTURE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define TDBTORTURE_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_TDBTEST_DEBUG)
	#define TDBTEST_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define TDBTEST_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SPINLOCK_DEBUG)
/*
	#define SPINLOCK_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
#define SPINLOCK_DUMP(format, arg...) 		sp_spinlock_dbg(0, (format, ##arg))
# define sp_spinlock_dbg( level, body )		DEBUG( level, body )
#else
	#define SPINLOCK_DUMP(format, arg...) do{      }while(0)
# define sp_spinlock_dbg( level, body )		DEBUG( level, body )
#endif


#endif //_SP_LIB_DBG_H
