#ifndef _SP_LIB_DBG_H
#define _SP_LIB_DBG_H

//#include "sp_samba_dbg.h"
/*
#define SP_UTIL_DEBUG
#define SP_UTIL_SOCK_DEBUG
#define SP_USERNAME_DEBUG
#define SP_HASH_DEBUG
#define SP_TALLOC_DEBUG
*/
//#define SP_UTIL_DEBUG
//#define SP_HASH_DEBUG
//#define SP_TALLOC_DEBUG
//#define SP_SMBRUN_DEBUG
//#define SP_USERNAME_DEBUG

//#define SP_SYSTEM_DEBUG
//#define SP_MD4_DEBUG


#if      defined(SP_UTIL_DEBUG)
	#define  sp_utilTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_utilAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_utilTrace(format, args...)
	#define  sp_utilAssert(cond)
#endif


#if      defined(SP_UTIL_SOCK_DEBUG)
	#define  sp_util_sockTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_util_sockAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_util_sockTrace(format, args...)
	#define  sp_util_sockAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_USERNAME_DEBUG)
	#define USERNAME_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define USERNAME_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_HASH_DEBUG)
	#define  sp_util_sockTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_util_sockAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_util_sockTrace(format, args...)
	#define  sp_util_sockAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_TALLOC_DEBUG)
	#define  sp_util_sockTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_util_sockAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_util_sockTrace(format, args...)
	#define  sp_util_sockAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SMBRUN_DEBUG)
	#define  sp_smbrunTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_smbrunAssert(cond)                      assert(cond)
	#define SMBRUN_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_smbrunTrace(format, args...)
	#define  sp_smbrunAssert(cond)
	#define SMBRUN_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SYSTEM_DEBUG)
	#define  sp_systemTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_systemAssert(cond)                      assert(cond)
	#define SYSTEM_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_systemTrace(format, args...)
	#define  sp_systemAssert(cond)
	#define SYSTEM_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_MD4_DEBUG)
	#define  sp_md4Trace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_md4Assert(cond)                      assert(cond)
	#define MD4_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_md4Trace(format, args...)
	#define  sp_md4Assert(cond)
	#define MD4_DUMP(format, arg...) do{      }while(0)
#endif

#endif //_SP_LIB_DBG_H
