#ifndef _SP_LOCKING_DBG_H
#define _SP_LOCKING_DBG_H

//#include "sp_samba_dbg.h"
/*
#define SP_LOCKING_SLOW_DEBUG
#define SP_SHMEM_DEBUG


*/



#if      defined(SP_LOCKING_SLOW_DEBUG)
	#define  sp_locking_slowTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_locking_slowAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_locking_slowTrace(format, args...)
	#define  sp_locking_slowAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SHMEM_DEBUG)
	#define  sp_shmemTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_shmemAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_shmemTrace(format, args...)
	#define  sp_shmemAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif



#endif //_SP_LOCKING_DBG_H
