#ifndef _SP_PASSWD_DBG_H
#define _SP_PASSWD_DBG_H

#include "sp_samba_dbg.h"
/*
#define SP_PASSWD_DEBUG

*/
//#define SP_PASSWD_DEBUG


#if      defined(SP_PASSWD_DEBUG)
	#define  sp_passwdTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_passwdAssert(cond)                      assert(cond)
	#define PASSWD_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_passwdTrace(format, args...)
	#define  sp_passwdAssert(cond)
	#define PASSWD_DUMP(format, arg...) do{      }while(0)
#endif



#endif //_SP_PASSWD_DBG_H
