/**********************************************************************************  
 *  SecureSOHO v2 UPnP device by using Intel UPnP SDK v1.0.4
 *
 *   Revision 0.4.0
 *
 *   Copyright (c) 2001, 2002 REDSonic Inc. All rights reserved. 
 **********************************************************************************/

#ifndef COMMON_UTIL_H
#define COMMON_UTIL_H

#include "stdlib.h"
#include "./intel_upnpsdk-1.0.4/inc/upnp.h"
#include "./intel_upnpsdk-1.0.4/inc/tools/upnptools.h"

char* CommonUtil_GetElementValue(Upnp_Node node);
Upnp_NodeList CommonUtil_GetFirstServiceList(Upnp_Node);
char* CommonUtil_GetFirstDocumentItem(Upnp_Node, char *);
Upnp_Node CommonUtil_GetFirstDeviceList(Upnp_Node); 
char* CommonUtil_GetFirstElementItem(Upnp_Element, char *);
#ifdef CONSOLE_CMD
void CommonUtil_PrintEventType(Upnp_EventType);
int CommonUtil_PrintEvent(Upnp_EventType, void *);
#endif
int CommonUtil_FindAndParseService (Upnp_Document, char*, char*, char**, char**, char**,int);
void CommonUtil_MallocError(void);
/* char* CommonUtil_Trim( const char*); */
#endif /* UPNPSDK_UTIL_H */
