#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
static char buf[4096];
static char cmd[1024];

int get_num(char *prog);

int main(int argc,char *argv[])
{
  int min_process;
  int sleep_time;
  int i;

  if (argc < 5) {
    printf("Usage: watch_prog <name> <mininum number of process> <sleep time> <command>\n");
    exit(0);
  }

  min_process = atoi(argv[2]);
  sleep_time = atoi(argv[3]);
  *cmd = 0;
  for(i=4;i<argc;i++)
    strcat(cmd,argv[i]);
  while(1) {
    if (get_num(argv[1]) < min_process) {
      sprintf(buf,"killall %s;sleep 1;killall -9 %s",argv[1],argv[1]);
      system(buf);
      while(get_num(argv[1]) != 0);
      system(cmd);
    }
    sleep(sleep_time);
  }
}


int get_num(char *prog)
{
  FILE *fp;
  char *s;
  int num;
  sprintf(buf,"pidof %s >/tmp/watch_process",prog);
  system(buf);
  fp = fopen("/tmp/watch_process","r");
  if (fp==NULL) {
    perror("fopen");
    exit(0);
  }
  *buf = 0;
  fgets(buf,4096,fp);
  num=0;
  s = buf;
  if (*s<'0'||*s>'9')
    return 0;
  while(*s) {
    if (*s == ' ') num++;
    s++;
  }
  fclose(fp);
  unlink("/tmp/watch_process");
  return num + 1;
}
