
#include <stdio.h>
#include <stdlib.h>
#include "extern.h"
#include <unistd.h>
#include <string.h>

/*
	(return value)
	
	in root ==============================
		You are in root directory = 1111
		
	hit data ===============
		read only  = 1100
		read write = 1010
		no access  = 1001
	========================
		miss data  = 0000
		can't open configure file = 0001
*/
extern int	 guest;
int root_flag;

int sec_right(char *directory,char *user_name, int flag)
{
	int flag_dir=0;
	//int opencount=0;  	// count the ftpd.conf open times
	int i=0;			// for loop	
	char bf[18]={0};	// The data buffer	
	FILE *f; 

//== Modify by George 09232004 ======================
	root_flag=1;
	if (directory[0]=='/' && directory[1]==0x00)
		return 0x1111;
	directory++;
	for(i=0;i<strlen(directory);i++) {
		if(directory[i]=='/') {
			root_flag=0;			
			directory[i]=0x00;
//			break;
			goto doit;
		}
	}
	
	if (flag == 1)
		root_flag=0;

doit:
	if((f = fopen("/.ftpd.conf","r")) == NULL)
	{
//		HDBG("ftpd.conf open error !!!! \n");
//		HDBG("Please check the config file. \n");
//		reply(550, "ftpd.conf open error !!!! \n");
		reply(550,"Can't accuss FTP configuration file!");
		exit(1);
	}
//----------------------------------------------------------------

	while(!feof(f))
	{
		//--------------------------------------
		//	Get the ftpd.conf element
		//--------------------------------------
		for(i=0;i<18;i++)
		{
			bf[i]=fgetc(f);
//			HDBG("{%2d}",bf[i]);
		}
//			HDBG("\n(%s)\n",(bf+1));
		
		//--------------------------------------
		//  Compare the directory name
		//--------------------------------------
		if((flag_dir == 0)&&( bf[0] & ns_CHK )&&(!strcmp(bf+1,directory)))
		{
			
			if( bf[0] == ns_SHARE )
			{
//				HDBG("You are in Share mode !!");
//				HDBG(" (%s) \n",(bf+1));				
				fclose(f);
				if (guest)
					return user_RO;
				else
					return user_RW;
			}else
			if( bf[0] == ns_NORMAL )
			{
				flag_dir=1; // need more check !!
			//++++++++++++++++++++++++++++++++++++++++++
//				HDBG("You are normal mode !!");
//				HDBG(" (%s) \n",(bf+1));		
				continue;
			//++++++++++++++++++++++++++++++++++++++++++
			}else
			{
//				printf("Unknow directory type !!");
//				HDBG("Unknow directory type !!");
//				HDBG("ftpd.conf crash !!!");
//				HDBG(" (%s) \n",(bf+1));
//				exit(2);
			}
			
		}

		//--------------------------------------
		//  Now you are a normal file type
		//	Find your own security right!!
		//--------------------------------------
		if((flag_dir == 1) && (bf[0] & user_CHK) && (!strcmp(bf+1,user_name)))
		{
			//-------------------------
			if(bf[0] == RO)
			{
				fclose(f);
				return user_RO;
			}
			//-------------------------
			if(bf[0] == RW)
			{
				fclose(f);
				return user_RW;
			}
			//-------------------------
			if(bf[0] == INV)
			{
				fclose(f);
				return user_NO;
			}
			//-------------------------
		} // end of if
		
	}
	fclose(f);

//	HDBG("%s \n",directory);
//	HDBG("%s \n",user);
	return MISS;
//----------------------------------------------------------------
}


int Get_IP_Security(char *check_ip)
{
	FILE *f1=NULL, *f2=NULL;
	char LineBuf[256], command[80], check_mac[30];
	char *ptr, *end;
	int i = 0, k = 0, result = 0;
	int pid;
	char cmd[15];
	char hosts_allow[20][20], hosts_deny[20][20];

	if((f1 = fopen("/etc/smb.conf", "r")) == NULL)
		return 0;

	//First, read the latest configuration
	while( fgets(LineBuf, 255, f1) != NULL ) {
		if((ptr = strstr(LineBuf, "hosts allow = ")) != NULL) {
			ptr += 14;
			while(*ptr != '\0') {
				if (*ptr != 0x3A) {
					hosts_allow[i][k] = *ptr;
					k++;  ptr++;
				}
				else {
					hosts_allow[i][k] = '\0';
					i++;  ptr++;  k = 0;
				}
			}
			hosts_allow[i][k-1] = '\0';
		}
		
		i = 0;  k = 0;
		if((ptr = strstr(LineBuf, "hosts deny = ")) != NULL) {
			ptr += 13;
			while(*ptr != '\0') {
				if (*ptr != 0x3A) {
					hosts_deny[i][k] = *ptr;
					k++;  ptr++;
				}
				else {
					hosts_deny[i][k] = '\0';
					i++;  ptr++;  k = 0;
				}
			}
			hosts_deny[i][k-1] = '\0';
		}
	}
	fclose(f1);

	//IP and MAC security are both disabled
	if(**hosts_deny == '\0' && **hosts_allow == '\0')
		return 0;
	
	//Get the access MAC
	//sprintf(command, "arp %s > /var/run/checkmac", check_ip);
	//system(command);
	
	pid=getpid();
	sprintf(command, "/etc/init.d/arp.sh %s %d", check_ip,pid);
	system(command);
	
	sleep(1);
	//if((f2 = fopen("/var/run/checkmac", "r")) == NULL)
	sprintf(cmd, "/tmp/mac.%d",pid);
	if((f2 = fopen(cmd, "r")) == NULL)
		return (result);
	else{
		while(fgets(LineBuf, 255, f2) != NULL) {
			if((ptr = strstr(LineBuf, check_ip)) != NULL) {
				ptr = strchr(LineBuf, '*');
				ptr++;
				end = strchr(ptr, ']');
				*end = '\0';
				strcpy(check_mac, ptr);
				
			}
		}
		for ( i=2; i<15; i+=3) {
			check_mac[i] = 0x2E;
		}
	}
	fclose(f2);
	sprintf(command, "rm -f %s",cmd);
	system(command);


	if(**hosts_allow != '\0') {
		//Check the allow hosts
		for(i=0; i<20; i++) {
			//Check the IP
			if(!strncmp(check_ip, hosts_allow[i], strlen(check_ip))) {
				//printf("mode = 1: check_ip = %s and hosts_allow[i] = %s\n", check_ip, hosts_allow[i]);
				return 0;    //PERMITTED!!
			}
			//Check the MAC
			if(!strncasecmp(check_mac, hosts_allow[i], strlen(check_mac)) && *check_mac != '\0'){
				//printf("mode = 1: checkmac = %s and hosts_allow[i] = %s\n", checkmac, hosts_allow[i]);
				return 0;    //PERMITTED!!
			}
		}
		if(**hosts_deny == '\0')
			return 1;
	}
	//Check the deny hosts
	for(i=0; i<20; i++) {
		//Check the IP
		if(!strncmp(check_ip, hosts_deny[i], strlen(check_ip))) {
			//printf("mode = 1: check_ip = %s and hosts_deny[i] = %s\n", check_ip, hosts_deny[i]);
			return 1;    //NOT ALLOWED!!
		}
		//Check the MAC
		if(!strncasecmp(check_mac, hosts_deny[i], strlen(check_mac)) && *check_mac != '\0') {
			//printf("mode = 1: checkmac = %s and hosts_deny[i] = %s\n", checkmac, hosts_deny[i]);
			return 1;    //NOT ALLOWED!!
		}
	}
	return 0;    //PERMITTED!!
}

