typedef struct{
    const char *name;    /* The name of WEB field */
    char *value;
} WEB_VAR;

//data: a pointer to the encoded form data
//out: a file pointer used for output
typedef void cgi_handler(char *data, FILE *out);

typedef struct{
    const char *name;      /* The name of the script as given in the URL */
    cgi_handler *handler;  /* The function which should be called */
} CGI_ENTRY;

typedef struct{
    const char *name;  /* Argument name to look for */
    char *var;         /* Variable to copy value into, if present */
    int len;           /* Max length of string, including terminator */
} ARGUMENT;

int fd;
int content_length;
//static char fmversion[10];
//static char hdcapacity[20];
