
typedef struct{
    char filename[4096];
    char dirname[4096];
    char pid[11];
    char status[5];
    char peer[3];
    char piece_receive[11];
    char piece_file[11];
    char piece_peer[11];
    char download_bw[15];
    char upload_bw[15];
    char tracker[6];
    char piece_exist[11];
    char piece_total[11];
    char piece_len[11];
    char listen_port[6];
    int condition;
}DOWNLOAD_STATUS;

typedef struct{
    char filename[4096];
    char dirname[4096];
    char hours[3];
    char port[6];
    char max_peer[3];
    char min_peer[3];
    char max_bw[8];
    char min_bw[8];
    char time[20];
}CONFIGURATION_DATA;

typedef struct{
    char filename[1024];
    char dirname[1024];
    char pid[11];
}DELETE_DATA;

typedef struct{
    char filename[1024];
    char time[22];
    char execute[3]; //this must be three bytes to accomodates strcpy(xxx,"1"),to avoid possible error
}DOWNLOAD_DATA;

typedef struct{
    char filename[1024];
    char time[22];
    char execute[3]; //this must be three bytes to accomodates strcpy(xxx,"1"),to avoid possible error
}DOWNLOAD_DATA_TEMP;

typedef struct{
    char filename[1024];
    char time[22];
    char execute[3];
}DOWNLOAD_DATA_TEMP_HISTORY;

void get_start_time(char *compare, char *time, char *dir_name, char *max_bw, char *min_bw);
void check_torrent_status(FILE *out);
void read_queue_data(void);
void parse_del_torrent(int *count,DELETE_DATA *del_torrent,char *get_data);
void parse_download_torrent(int *add_count,DOWNLOAD_DATA *ADD_FILE,char *get_data);
void kill_finished_process(char *dir_name,char *file_name, char *pid);
void cron_del_download(void);
