#ifndef _SP_FTPD_DBG_H
#define _SP_FTPD_DBG_H


#define SP_FTPD_DEBUG

#if      defined(SP_FTPD_DEBUG)
	#define  sp_ftpdTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_ftpdAssert(cond)                      assert(cond)
	#define FTPD_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_ftpdTrace(format, args...)
	#define  sp_ftpdAssert(cond)
	#define FTPD_DUMP(format, arg...) do{      }while(0)
#endif



#endif //_SP_FTPD_DBG_H
