#ifndef _SP_NSSWITCH_DBG_H
#define _SP_NSSWITCH_DBG_H
/*
//#include "sp_samba_dbg.h"
#define SP_NSSWITCH_DEBUG
*/

#if      defined(SP_NSSWITCH_DEBUG)
/*
	#define NSSWITCH_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define NSSWITCH_DUMP(format, arg...) 		sp_nsswitch_dbg(0, (format, ##arg))
# define sp_nsswitch_dbg( level, body )		DEBUG( level, body )
#else
# define NSSWITCH_DUMP(format, arg...) do{      }while(0)
# define sp_nsswitch_dbg( level, body )		
#endif


#endif //_SP_NSSWITCH_DBG_H
