#ifndef _SP_PRINTING_DBG_H
#define _SP_PRINTING_DBG_H

//#include "sp_samba_dbg.h"

//#define SP_PRINTING_DEBUG


#if      defined(SP_PRINTING_DEBUG)
	#define  sp_printingTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_printingAssert(cond)                      assert(cond)
/*	
	#define PRINTING_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define PRINTING_DUMP(format, arg...) 		sp_printing_dbg(0, (format, ##arg))
# define sp_printing_dbg( level, body )		DEBUG( level, body )
#else
	#define  sp_printingTrace(format, args...)
	#define  sp_printingAssert(cond)
	#define PRINTING_DUMP(format, arg...) do{      }while(0)
# define sp_printing_dbg( level, body )		
#endif




#endif //_SP_PRINTING_DBG_H
