#ifndef _SP_SMBD_DBG_H
#define _SP_SMBD_DBG_H

//#include "sp_samba_dbg.h"

/*
#define SP_MESSAGE_DEBUG
#define SP_CONNECTION_DEBUG
#define SP_DOSMODE_DEBUG
#define SP_CHGPASSWD_DEBUG
#define SP_OPEN_DEBUG
#define SP_PIPES_DEBUG
#define SP_PROCESS_DEBUG
#define SP_REPLY_DEBUG
#define SP_TRANS2_DEBUG
#define SP_SERVER_DEBUG
#define SP_FILENAME_DEBUG
*/
/*
//#define SP_FILENAME_DEBUG
#define SP_SERVER_DEBUG
//#define SP_SERVER_DEBUG_1
//#define SP_PROCESS_DEBUG
#define SP_PASSWORD_DEBUG
//#define SP_PASSWORD_DEBUG_1
#define SP_SERVICE_DEBUG
//#define SP_MESSAGE_DEBUG
//#define SP_CLOSE_DEBUG
//#define SP_REPLY_DEBUG
//#define SP_IPC_DEBUG
*/
/*
//#define SP_SERVER_DEBUG
//#define SP_PASSWORD_DEBUG

#define SP_SERVICE_DEBUG
#define SP_UID_DEBUG
#define SP_SEC_CTX_DEBUG
#define SP_POSIX_ACLS_DEBUG
*/
#define SP_UID_DEBUG
#define SP_SESSSETUP_DEBUG
#define SP_PROCESS_DEBUG
#define SP_REPLY_DEBUG
#define SP_PASSWORD_DEBUG
#define SP_SERVER_DEBUG
#define SP_SERVICE_DEBUG

#if      defined(SP_MESSAGE_DEBUG)
	#define  sp_messageTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_messageAssert(cond)                      assert(cond)
	#define MESSAGE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_messageTrace(format, args...)
	#define  sp_messageAssert(cond)
	#define MESSAGE_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_CONNECTION_DEBUG)
	#define  sp_connectionTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_connectionAssert(cond)                      assert(cond)
	#define CONNECTION_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_connectionTrace(format, args...)
	#define  sp_connectionAssert(cond)
	#define CONNECTION_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_DOSMODE_DEBUG)
	#define  sp_dosmodeTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_dosmodeAssert(cond)                      assert(cond)
	#define DOSMODE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_dosmodeTrace(format, args...)
	#define  sp_dosmodeAssert(cond)
	#define DOSMODE_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_CHGPASSWD_DEBUG)
	#define  sp_chgpasswdTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_chgpasswdAssert(cond)                      assert(cond)
	#define CHGPASSWD_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_chgpasswdTrace(format, args...)
	#define  sp_chgpasswdAssert(cond)
	#define CHGPASSWD_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_OPEN_DEBUG)
	#define  sp_openTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_openAssert(cond)                      assert(cond)
	#define OPEN_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_openTrace(format, args...)
	#define  sp_openAssert(cond)
	#define OPEN_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_PIPES_DEBUG)
	#define  sp_pipesTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_pipesAssert(cond)                      assert(cond)
	#define PIPES_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_pipesTrace(format, args...)
	#define  sp_pipesAssert(cond)
	#define PIPES_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_PROCESS_DEBUG)
/*	
	#define PROCESS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
	# define SEC_PROCESS_DUMP(format, arg...) 		sp_process_dbg(0, (format, ##arg))
	# define sp_process_dbg( level, body )		DEBUG( level, body )
#else
	#define  SEC_PROCESS_DUMP(format, args...)
	#define  sp_process_dbg(cond)
//	#define PROCESS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_REPLY_DEBUG)
	# define SEC_REPLY_DUMP(format, arg...) 		sp_reply_dbg(0, (format, ##arg))
	# define sp_reply_dbg( level, body )			DEBUG( level, body )
/*	
	#define SEC_REPLY_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
#else
	# define SEC_REPLY_DUMP(format, arg...) 		
	# define sp_reply_dbg( level, body )	
	//#define REPLY_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_TRANS2_DEBUG)
	#define  sp_trans2Trace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_trans2Assert(cond)                      assert(cond)
	#define TRANS2_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_trans2Trace(format, args...)
	#define  sp_trans2Assert(cond)
	#define TRANS2_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_CHGPASSWD_DEBUG)
	#define  sp_chgpasswdTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_chgpasswdAssert(cond)                      assert(cond)
	#define CHGPASSWD_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_chgpasswdTrace(format, args...)
	#define  sp_chgpasswdAssert(cond)
	#define CHGPASSWD_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_SERVER_DEBUG)
	#define  sp_serverTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_serverAssert(cond)                      assert(cond)
/*	
	#define SERVER_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
/*
	#define SERVER3_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define SERVER_DUMP(format, arg...) 		sp_server_dbg(0, (format, ##arg))
# define sp_server_dbg( level, body )		DEBUG( level, body )

#else
	#define  sp_serverTrace(format, args...)
	#define  sp_serverAssert(cond)
	#define SERVER_DUMP(format, arg...) do{      }while(0)
# define sp_server_dbg( level, body )		
#endif

#if      defined(SP_SERVER_DEBUG_1)
	
#define SERVER_DBG(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)

#else
	#define SERVER_DBG(format, arg...) do{      }while(0)
#endif


#if      defined(SP_FILENAME_DEBUG)
	#define  sp_filenameTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_filenameAssert(cond)                      assert(cond)
	#define FILENAME_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_filenameTrace(format, args...)
	#define  sp_filenameAssert(cond)
	#define FILENAME_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_PASSWORD_DEBUG)
	#define  sp_passwordTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_passwordAssert(cond)                      assert(cond)
/*	
	#define PASSWORD_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define PASSWORD_DUMP(format, arg...) 		sp_password_dbg(0, (format, ##arg))
# define sp_password_dbg( level, body )		DEBUG( level, body )
#else
	#define  sp_passwordTrace(format, args...)
	#define  sp_passwordAssert(cond)
	#define PASSWORD_DUMP(format, arg...) do{      }while(0)
# define sp_password_dbg( level, body )		
#endif

#if      defined(SP_PASSWORD_DEBUG_1)
	#define PASSWORD_DUMP_1(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define PASSWORD_DUMP_1(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SERVICE_DEBUG)
	#define  sp_serviceTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_serviceAssert(cond)                      assert(cond)
/*	
	#define SERVICE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define SERVICE_DUMP(format, arg...) 		sp_service_dbg(0, (format, ##arg))
# define sp_service_dbg( level, body )		DEBUG( level, body )
#else
	#define  sp_serviceTrace(format, args...)
	#define  sp_serviceAssert(cond)
	#define SERVICE_DUMP(format, arg...) do{      }while(0)
# define sp_service_dbg( level, body )		
#endif

#if      defined(SP_MESSAGE_DEBUG)
	#define  sp_messageTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_messageAssert(cond)                      assert(cond)
	#define MESSAGE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_messageTrace(format, args...)
	#define  sp_messageAssert(cond)
	#define MESSAGE_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_CLOSE_DEBUG)
	#define  sp_closeTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_closeAssert(cond)                      assert(cond)
	#define CLOSE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_closeTrace(format, args...)
	#define  sp_closeAssert(cond)
	#define CLOSE_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_IPC_DEBUG)
	#define  sp_ipcTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_ipcAssert(cond)                      assert(cond)
	#define IPC_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_ipcTrace(format, args...)
	#define  sp_ipcAssert(cond)
	#define IPC_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_UID_DEBUG)
/*
	#define IPC_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define UID_DUMP(format, arg...) 		sp_uid_dbg(0, (format, ##arg))
# define sp_uid_dbg( level, body )		DEBUG( level, body )
#else
	//#define IPC_DUMP(format, arg...) do{      }while(0)
# define UID_DUMP(format, arg...) 		
# define sp_uid_dbg( level, body )		
#endif


#if      defined(SP_SEC_CTX_DEBUG)
/*
	#define IPC_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define SEC_CTX_DUMP(format, arg...) 		sp_sec_ctx_dbg(0, (format, ##arg))
# define sp_sec_ctx_dbg( level, body )		DEBUG( level, body )
#else
	//#define IPC_DUMP(format, arg...) do{      }while(0)
# define SEC_CTX_DUMP(format, arg...) 		
# define sp_sec_ctx_dbg( level, body )		
#endif


#if      defined(SP_POSIX_ACLS_DEBUG)
/*
	#define POSIX_ACLS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define POSIX_ACLS_DUMP(format, arg...) 		sp_posix_acls_dbg(0, (format, ##arg))
# define sp_posix_acls_dbg( level, body )		DEBUG( level, body )
#else
	//#define IPC_DUMP(format, arg...) do{      }while(0)
# define POSIX_ACLS_DUMP(format, arg...) 		
# define sp_posix_acls_dbg( level, body )		
#endif


#if      defined(SP_SESSSETUP_DEBUG)
/*
	#define SESSSETUP_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
*/
# define SESSSETUP_DUMP(format, arg...) 		sp_sesssetup_dbg(0, (format, ##arg))
# define sp_sesssetup_dbg( level, body )		DEBUG( level, body )
#else
	//#define SESSSETUP_DUMP(format, arg...) do{      }while(0)
# define SESSSETUP_DUMP(format, arg...) 		
# define sp_sesssetup_dbg( level, body )		
#endif


#endif //_SP_SMBD_DBG_H
