#ifndef _SP_LIBSMBD_DBG_H
#define _SP_LIBSMBD_DBG_H

/*
#define SP_CLIENTGEN_DEBUG

*/
//#define SP_CLIENTGEN_DEBUG

//#define SP_SMBENCRYPT_DEBUG
//#define SP_SMBDES_DEBUG


#if      defined(SP_CLIENTGEN_DEBUG)
	#define  sp_clientgenTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_clientgenAssert(cond)                      assert(cond)
	#define CLIENTGEN_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_clientgenTrace(format, args...)
	#define  sp_clientgenAssert(cond)
	#define CLIENTGEN_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_SMBENCRYPT_DEBUG)
	# define  sp_smbencryptTrace(fmt,arg...)                 printf(fmt,##arg)
	# define  sp_smbencryptAssert(cond)                      assert(cond)
	# define SMBENCRYPT_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	# define  sp_smbencryptTrace(format, args...)
	# define  sp_smbencryptAssert(cond)
	# define SMBENCRYPT_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_SMBDES_DEBUG)
	# define  sp_smbdesTrace(fmt,arg...)                 printf(fmt,##arg)
	# define  sp_smbdesAssert(cond)                      assert(cond)
	# define SMBDES_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	# define  sp_smbdesTrace(format, args...)
	# define  sp_smbdesAssert(cond)
	# define SMBDES_DUMP(format, arg...) do{      }while(0)
#endif


#endif //_SP_LIBSMBD_DBG_H
