#ifndef _SP_NMBD_DBG_H
#define _SP_NMBD_DBG_H

//#include "sp_samba_dbg.h"
/*
#define SP_NMBD_PACKETS_DEBUG
#define SP_NMBD_INCOMINGREQUESTS_DEBUG
*/
//#define SP_NMBD_WINSSERVER_DEBUG
//#define SP_NMBD_INCOMINGREQUESTS_DEBUG


#if      defined(SP_NMBD_PACKETS_DEBUG)
	#define  sp_nmbd_packetsTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_nmbd_packetsAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_nmbd_packetsTrace(format, args...)
	#define  sp_nmbd_packetsAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_NMBD_INCOMINGREQUESTS_DEBUG)
	#define  sp_nmbd_incomingrequestsTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_nmbd_incomingrequestsAssert(cond)                      assert(cond)
	#define NMBD_INCOMINGREQUESTS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_nmbd_incomingrequestsTrace(format, args...)
	#define  sp_nmbd_incomingrequestsAssert(cond)
	#define NMBD_INCOMINGREQUESTS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_NMBD_WINSSERVER_DEBUG)
	#define  sp_nmbd_winsserverTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_nmbd_winsserverAssert(cond)                      assert(cond)
	#define NMBD_WINSSERVER_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_nmbd_winsserverTrace(format, args...)
	#define  sp_nmbd_winsserverAssert(cond)
	#define NMBD_WINSSERVER_DUMP(format, arg...) do{      }while(0)
#endif




#endif //_SP_NMBD_DBG_H
