#ifndef _SP_PARAM_DBG_H
#define _SP_PARAM_DBG_H

//#include "sp_samba_dbg.h"
/*
#define SP_MESSAGE_DEBUG
#define SP_CONNECTION_DEBUG
#define SP_DOSMODE_DEBUG
#define SP_CHGPASSWD_DEBUG
#define SP_OPEN_DEBUG
#define SP_PIPES_DEBUG
#define SP_PROCESS_DEBUG
#define SP_REPLY_DEBUG
#define SP_TRANS2_DEBUG
#define SP_CHGPASSWD_DEBUG
#define SP_SERVER_DEBUG
#define SP_LOADPARAM_DEBUG
*/
//#define SP_LOADPARAM_DEBUG


#if      defined(SP_MESSAGE_DEBUG)
	#define  sp_messageTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_messageAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_messageTrace(format, args...)
	#define  sp_messageAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_CONNECTION_DEBUG)
	#define  sp_connectionTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_connectionAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_connectionTrace(format, args...)
	#define  sp_connectionAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_DOSMODE_DEBUG)
	#define  sp_dosmodeTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_dosmodeAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_dosmodeTrace(format, args...)
	#define  sp_dosmodeAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_CHGPASSWD_DEBUG)
	#define  sp_chgpasswdTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_chgpasswdAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_chgpasswdTrace(format, args...)
	#define  sp_chgpasswdAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_OPEN_DEBUG)
	#define  sp_openTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_openAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_openTrace(format, args...)
	#define  sp_openAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_PIPES_DEBUG)
	#define  sp_pipesTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_pipesAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_pipesTrace(format, args...)
	#define  sp_pipesAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_PROCESS_DEBUG)
	#define  sp_processTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_processAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_processTrace(format, args...)
	#define  sp_processAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_REPLY_DEBUG)
	#define  sp_replyTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_replyAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_replyTrace(format, args...)
	#define  sp_replyAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_TRANS2_DEBUG)
	#define  sp_trans2Trace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_trans2Assert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_trans2Trace(format, args...)
	#define  sp_trans2Assert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_CHGPASSWD_DEBUG)
	#define  sp_chgpasswdTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_chgpasswdAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_chgpasswdTrace(format, args...)
	#define  sp_chgpasswdAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_SERVER_DEBUG)
	#define  sp_serverTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_serverAssert(cond)                      assert(cond)
	#define CONS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_serverTrace(format, args...)
	#define  sp_serverAssert(cond)
	#define CONS_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_LOADPARAM_DEBUG)
	#define  sp_serverTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_serverAssert(cond)                      assert(cond)
	#define LOADPARAM_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_serverTrace(format, args...)
	#define  sp_serverAssert(cond)
	#define LOADPARAM_DUMP(format, arg...) do{      }while(0)
#endif



#endif //_SP_PARAM_DBG_H
