#ifndef _SP_PASSDB_DBG_H
#define _SP_PASSDB_DBG_H

/*
#define SP_SMBPASS_DEBUG
#define SP_PASSDB_DEBUG
#define SP_SMBPASSFILE_DEBUG
*/
//#define SP_SMBPASS_DEBUG
//#define SP_PASSDB_DEBUG
//#define SP_SMBPASSFILE_DEBUG
//#define SP_SMBPASSCHANGE_DEBUG


#if      defined(SP_SMBPASS_DEBUG)
	#define  sp_smbpassTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_smbpassAssert(cond)                      assert(cond)
	#define SMBPASS_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_smbpassTrace(format, args...)
	#define  sp_smbpassAssert(cond)
	#define SMBPASS_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_PASSDB_DEBUG)
	#define  sp_passdbTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_passdbAssert(cond)                      assert(cond)
	#define PASSDB_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_passdbTrace(format, args...)
	#define  sp_passdbAssert(cond)
	#define PASSDB_DUMP(format, arg...) do{      }while(0)
#endif


#if      defined(SP_SMBPASSFILE_DEBUG)
	#define  sp_smbpassfileTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_smbpassfileAssert(cond)                      assert(cond)
	#define SMBPASSFILE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_smbpassfileTrace(format, args...)
	#define  sp_smbpassfileAssert(cond)
	#define SMBPASSFILE_DUMP(format, arg...) do{      }while(0)
#endif

#if      defined(SP_SMBPASSCHANGE_DEBUG)
	#define  sp_smbpasschangeTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_smbpasschangeAssert(cond)                      assert(cond)
	#define SMBPASSCHANGE_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_smbpasschangeTrace(format, args...)
	#define  sp_smbpasschangeAssert(cond)
	#define SMBPASSCHANGE_DUMP(format, arg...) do{      }while(0)
#endif


#endif //_SP_PASSDB_DBG_H
