#ifndef _SP_SMBPASSWD_DBG_H
#define _SP_SMBPASSWD_DBG_H

#include "sp_samba_dbg.h"
/*
#define SP_SMBPASSWD_DEBUG

*/
//#define SP_SMBPASSWD_DEBUG


#if      defined(SP_SMBPASSWD_DEBUG)
	#define  sp_smbpasswdTrace(fmt,arg...)                 printf(fmt,##arg)
	#define  sp_smbpasswdAssert(cond)                      assert(cond)
	#define SMBPASSWD_DUMP(format, arg...) do{      \
FILE *f; \
f = fopen("/dev/console","w+");        \
fprintf(f,format , ## arg);                \
fclose(f); \
}while(0)
#else
	#define  sp_smbpasswdTrace(format, args...)
	#define  sp_smbpasswdAssert(cond)
	#define SMBPASSWD_DUMP(format, arg...) do{      }while(0)
#endif







#endif //_SP_SMBPASSWD_DBG_H
